/**
Master Project WS-2004 ~ SS-2005, Computer Science

University of Fribourg, Information Systems Research Group (http://diuf.unifr.ch/is)

Student :    Amos Brocco <amos.brocco@unifr.ch>
Supervisors: Prof. Dr. Andreas Meier <andreas.meier@unifr.ch>
             Nicolas Werro <nicolas.werro@unifr.ch>
        __  __
 _ _ ___\ \/ /__ _ _ _  _ _  ___
| '_/ _ \>  </ _` | ' \| ' \/ -_)
|_| \___/_/\_\__,_|_||_|_||_\___|

roXanne, Secure XML Data Storage Framework
x.core & x.click Copyright (C) 2004-2005 Amos Brocco <amos.brocco@unifr.ch>
x.mill Copyright (C) 2004-2005 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

This product includes software developed by the JDOM Project (http://www.jdom.org/).
The Jaxup library is Copyright (c) 2001 - 2003 Erwin Bolwidt, used and modified under the BSD License.
Encryption modules used are Copyright (c) 2000 - 2004 The Legion Of The Bouncy Castle (http://www.bouncycastle.org).
JAXEN  is Copyright 2003 (C) The Werken Company. All Rights Reserved.
Base64 was released as Public Domain by its author Robert Harder (rob@iharder.net)
MySQL JDBC Connector is (c) 1995-2005 MySQL AB. All rights reserved. Released under the GNU/GPL License.
PostgreSQL JDBC Driver is Copyright (c) 2004-2005 The PostgreSQL Global Development Group, distributed under the BSD license
JArgs was created Steve Purcell, now mantained by Ewan Mellorby and released under the BSD licence.
**/

/*
 * Debug messages management
 */
package debug;

import java.text.DateFormat;
import java.util.Date;

/**
 * Debuginfo
 * 
 * This class is not instantiated directly, but it's used to output debug
 * informations. Instead of using the common System.out.println, this class
 * provides a way to differentiate debug messages.
 * Levels over 10 indicate that we do not want a new line for each debug text
 * 
 * @author mriya3
 *  
 */
public class Debuginfo {
	// TODO: Maybe add write to file option?

	/* The default debug level is 0 */
	private static int debuglevel = 0;

	/**
	 * This constructor is accessed in a static way to output messages
	 * on the console.
	 * 
	 * @param level
	 * @param message
	 */
	public Debuginfo(int level, String message) {
		String levelstring = null;
		boolean noNewLine;
		if(level >= 10) {
			level = level - 10;
			noNewLine = true;
		} else noNewLine = false;
		if (level >= Debuginfo.debuglevel) {
			switch (level) {
			case 0:
				levelstring = "<bogus>    ";
				break;
			case 1:
				levelstring = "<info>     ";
				break;
			case 2:
				levelstring = "<warning>  ";
				break;
			case 3:
				levelstring = "<alert>    ";
				break;
			case 4:
				levelstring = "<critical> ";
				break;
			case 5:
				levelstring = "<fatal>    ";
				break;
			default:
				levelstring = "<verbose>  ";
			}
			Date d = new Date();
			DateFormat df = DateFormat.getDateTimeInstance(DateFormat.SHORT,
					DateFormat.MEDIUM);
			String td = df.format(d);
			if(!noNewLine)
				System.out.println(levelstring + "[" + td + "] :: " + message);
			else
				System.out.print(levelstring + "[" + td + "] :: " + message);
		}
	}

	/**
	 * Sets the debuglevel limit for message printing
	 * 
	 * @param level
	 */
	public static void setDebugLevel(int level) {
		Debuginfo.debuglevel = level;
	}

	/**
	 * Gets the current debug level limit
	 * 
	 * @return
	 */
	public static int getDebugLevel() {
		return Debuginfo.debuglevel;
	}

}