/**
Master Project WS-2004 ~ SS-2005, Computer Science

University of Fribourg, Information Systems Research Group (http://diuf.unifr.ch/is)

Student :    Amos Brocco <amos.brocco@unifr.ch>
Supervisors: Prof. Dr. Andreas Meier <andreas.meier@unifr.ch>
             Nicolas Werro <nicolas.werro@unifr.ch>
        __  __
 _ _ ___\ \/ /__ _ _ _  _ _  ___
| '_/ _ \>  </ _` | ' \| ' \/ -_)
|_| \___/_/\_\__,_|_||_|_||_\___|

roXanne, Secure XML Data Storage Framework
x.core & x.click Copyright (C) 2004-2005 Amos Brocco <amos.brocco@unifr.ch>
x.mill Copyright (C) 2004-2005 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

This product includes software developed by the JDOM Project (http://www.jdom.org/).
The Jaxup library is Copyright (c) 2001 - 2003 Erwin Bolwidt, used and modified under the BSD License.
Encryption modules used are Copyright (c) 2000 - 2004 The Legion Of The Bouncy Castle (http://www.bouncycastle.org).
JAXEN  is Copyright 2003 (C) The Werken Company. All Rights Reserved.
Base64 was released as Public Domain by its author Robert Harder (rob@iharder.net)
MySQL JDBC Connector is (c) 1995-2005 MySQL AB. All rights reserved. Released under the GNU/GPL License.
PostgreSQL JDBC Driver is Copyright (c) 2004-2005 The PostgreSQL Global Development Group, distributed under the BSD license
JArgs was created Steve Purcell, now mantained by Ewan Mellorby and released under the BSD licence.
**/

/*
 * Root Environment
 * 
 * The root environment class is essentially the same as environment
 * but to differentiate between environments at runtime we prefer
 * to use a different class.
 */
package environments;

import org.jdom.Document;

/**
 * Root environment class
 * 
 * @author mriya3
 *
 */
public class RootEnvironment extends Environment {
	
	/* True if data is in-sync with data on disk */
	private boolean syncedOnDisk = true;
	
	private Document rootDocument;

	public RootEnvironment() {
		super(null);
	}
	
	/**
	 * Sets the environment as in-sync with disk data
	 *
	 */
	public void setSynced() {
		this.syncedOnDisk = true;
	}
	
	/**
	 * Sets the environment as not in-sync with disk data
	 *
	 */
	public void setUnSynced() {
		this.syncedOnDisk = false;
	}
	
	/**
	 * Returns the sync status
	 * @return
	 */
	public boolean getSyncedStatus() {
		return syncedOnDisk;
	}
	
	/**
	 * Returns the root document
	 */
	public Document getRootDocument() {
		return rootDocument;
	}
	
	/**
	 * Sets the root document to doc
	 * @param doc
	 */
	public void setRootDocument(Document doc) {
		this.rootDocument = doc;
	}

}
