package org.jdom.contrib.c14n;

import java.util.Comparator;

import org.jdom.Namespace;

/**
 * Compares two <code>Namespace</code> s in the context of canonical XML.
 * Namspace A compares lower to Namespace B if the prefix for A is
 * lexicographically lower than the prefix for B. The empty prefix is lesser
 * than non-empty prefixes.
 * 
 * @author Per Norrman
 *  
 */
class NamespaceComparator implements Comparator {

	public int compare(Object o1, Object o2) {
		Namespace n1 = (Namespace) o1;
		Namespace n2 = (Namespace) o2;
		return n1.getPrefix().compareTo(n2.getPrefix());
	}

}
