/**
Master Project WS-2004 ~ SS-2005, Computer Science

University of Fribourg, Information Systems Research Group (http://diuf.unifr.ch/is)

Student :    Amos Brocco <amos.brocco@unifr.ch>
Supervisors: Prof. Dr. Andreas Meier <andreas.meier@unifr.ch>
             Nicolas Werro <nicolas.werro@unifr.ch>
        __  __
 _ _ ___\ \/ /__ _ _ _  _ _  ___
| '_/ _ \>  </ _` | ' \| ' \/ -_)
|_| \___/_/\_\__,_|_||_|_||_\___|

roXanne, Secure XML Data Storage Framework
x.core & x.click Copyright (C) 2004-2005 Amos Brocco <amos.brocco@unifr.ch>
x.mill Copyright (C) 2004-2005 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

This product includes software developed by the JDOM Project (http://www.jdom.org/).
The Jaxup library is Copyright (c) 2001 - 2003 Erwin Bolwidt, used and modified under the BSD License.
Encryption modules used are Copyright (c) 2000 - 2004 The Legion Of The Bouncy Castle (http://www.bouncycastle.org).
JAXEN  is Copyright 2003 (C) The Werken Company. All Rights Reserved.
Base64 was released as Public Domain by its author Robert Harder (rob@iharder.net)
MySQL JDBC Connector is (c) 1995-2005 MySQL AB. All rights reserved. Released under the GNU/GPL License.
PostgreSQL JDBC Driver is Copyright (c) 2004-2005 The PostgreSQL Global Development Group, distributed under the BSD license
JArgs was created Steve Purcell, now mantained by Ewan Mellorby and released under the BSD licence.
**/

/*
 * DESede Key
 */
package security.DESede;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.security.NoSuchAlgorithmException;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.KeySpec;

import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.PBEKeySpec;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.jdom.output.XMLOutputter;

import security.Base64;
import security.InvalidKeyException;
import security.RXKey;

/**
 * @author mriya3
 *  
 */
public class MyDESedeKey implements RXKey {

	Object key = null;

	private String password;

	private byte[] salt = { (byte) 0xA9, (byte) 0x9B, (byte) 0xC8, (byte) 0x32,
			(byte) 0x56, (byte) 0x35, (byte) 0xE3, (byte) 0x03 };

	private int iterationCount = 19;

	public MyDESedeKey(String password) {
		this.password = password;
	}

	/**
	 *  
	 */
	public MyDESedeKey() {
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see security.RXKey#decode(java.lang.String)
	 */
	public void decode(String data) throws InvalidKeyException {
		ByteArrayInputStream indata = new ByteArrayInputStream(Base64
				.decode(data));
		SAXBuilder sb = new SAXBuilder();
		Document doc = null;
		try {
			doc = sb.build(indata);
		} catch (JDOMException e) {
			throw new InvalidKeyException();
		} catch (IOException e) {
			throw new InvalidKeyException();
		}
		Element root = doc.getRootElement();
		/* Verify root node name */
		if (!(root.getName().equals("RoXanneDESedeKey")))
			throw new InvalidKeyException();
		/* Extract parameters */
		password = root.getAttributeValue("password");
		/* Construct key object */
		if (password == null)
			throw new InvalidKeyException();
		update();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see security.RXKey#encode()
	 */
	public String encode() {
		Document doc = new Document();
		Element root = new Element("RoXanneDESedeKey");
		doc.setRootElement(root);
		root.setAttribute("password", this.password);
		XMLOutputter op = new XMLOutputter();
		String plainXML = op.outputString(doc);
		return Base64.encodeBytes(plainXML.getBytes());
	}

	public Object getKey() {
		return this.key;
	}

	public void update() {
		KeySpec keySpec = new PBEKeySpec(password.toCharArray(), salt,
				iterationCount);
		try {
			key = SecretKeyFactory.getInstance("PBEWithMD5AndDES")
					.generateSecret(keySpec);
		} catch (InvalidKeySpecException e) {
			key = null;
		} catch (NoSuchAlgorithmException e) {
			key = null;
		}
	}

}
