/**
Master Project WS-2004 ~ SS-2005, Computer Science

University of Fribourg, Information Systems Research Group (http://diuf.unifr.ch/is)

Student :    Amos Brocco <amos.brocco@unifr.ch>
Supervisors: Prof. Dr. Andreas Meier <andreas.meier@unifr.ch>
             Nicolas Werro <nicolas.werro@unifr.ch>
        __  __
 _ _ ___\ \/ /__ _ _ _  _ _  ___
| '_/ _ \>  </ _` | ' \| ' \/ -_)
|_| \___/_/\_\__,_|_||_|_||_\___|

roXanne, Secure XML Data Storage Framework
x.core & x.click Copyright (C) 2004-2005 Amos Brocco <amos.brocco@unifr.ch>
x.mill Copyright (C) 2004-2005 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

This product includes software developed by the JDOM Project (http://www.jdom.org/).
The Jaxup library is Copyright (c) 2001 - 2003 Erwin Bolwidt, used and modified under the BSD License.
Encryption modules used are Copyright (c) 2000 - 2004 The Legion Of The Bouncy Castle (http://www.bouncycastle.org).
JAXEN  is Copyright 2003 (C) The Werken Company. All Rights Reserved.
Base64 was released as Public Domain by its author Robert Harder (rob@iharder.net)
MySQL JDBC Connector is (c) 1995-2005 MySQL AB. All rights reserved. Released under the GNU/GPL License.
PostgreSQL JDBC Driver is Copyright (c) 2004-2005 The PostgreSQL Global Development Group, distributed under the BSD license
JArgs was created Steve Purcell, now mantained by Ewan Mellorby and released under the BSD licence.
**/

/*
 * ClientSession
 * 
 * This class stores data for a client connection to the server
 */
package application;


/**
 * @author mriya3
 * 
 */
public class ClientSession {

	private String address;

	private int port;

	private String login;

	private String password;

	private String sessionid;

	/**
	 * Sets the server address
	 * @param address
	 */
	public void setServerAddress(String address) {
		this.address = address;
	}

	/**
	 * Sets the server port
	 * @param port
	 */
	public void setServerPort(int port) {
		this.port = port;
	}

	/**
	 * Sets the login name
	 * @param login
	 */
	public void setLogin(String login) {
		this.login = login;
	}

	/**
	 * Sets the password
	 * @param password
	 */
	public void setPassword(String password) {
		this.password = password;
	}

	/**
	 * @return
	 */
	public String getServerAddress() {
		return address;
	}

	/**
	 * Returns the server port
	 * @return
	 */
	public int getServerPort() {
		return port;
	}

	/**
	 * Returns the password
	 * @return
	 */
	public String getPassword() {
		return password;
	}

	/**
	 * Returns the login name
	 * @return
	 */
	public String getLogin() {
		return login;
	}

	/**
	 * Returns the assigned session id
	 * @return
	 */
	public String getSessionId() {
		return sessionid;
	}

	/**
	 * Sets the current session id
	 * @param sessionid
	 */
	public void setSessionId(String sessionid) {
		this.sessionid = sessionid;
	}
}
