/**
Master Project WS-2004 ~ SS-2005, Computer Science

University of Fribourg, Information Systems Research Group (http://diuf.unifr.ch/is)

Student :    Amos Brocco <amos.brocco@unifr.ch>
Supervisors: Prof. Dr. Andreas Meier <andreas.meier@unifr.ch>
             Nicolas Werro <nicolas.werro@unifr.ch>
        __  __
 _ _ ___\ \/ /__ _ _ _  _ _  ___
| '_/ _ \>  </ _` | ' \| ' \/ -_)
|_| \___/_/\_\__,_|_||_|_||_\___|

roXanne, Secure XML Data Storage Framework
x.core & x.click Copyright (C) 2004-2005 Amos Brocco <amos.brocco@unifr.ch>
x.mill Copyright (C) 2004-2005 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

This product includes software developed by the JDOM Project (http://www.jdom.org/).
The Jaxup library is Copyright (c) 2001 - 2003 Erwin Bolwidt, used and modified under the BSD License.
Encryption modules used are Copyright (c) 2000 - 2004 The Legion Of The Bouncy Castle (http://www.bouncycastle.org).
JAXEN  is Copyright 2003 (C) The Werken Company. All Rights Reserved.
Base64 was released as Public Domain by its author Robert Harder (rob@iharder.net)
MySQL JDBC Connector is (c) 1995-2005 MySQL AB. All rights reserved. Released under the GNU/GPL License.
PostgreSQL JDBC Driver is Copyright (c) 2004-2005 The PostgreSQL Global Development Group, distributed under the BSD license
JArgs was created Steve Purcell, now mantained by Ewan Mellorby and released under the BSD licence.
**/

/*
 * Context Management
 * 
 * As session parameters are set, this class is used to connect
 * to the server to initialize the session, as well as to perform
 * further operations, such as logout.
 * 
 */
package application;

import java.io.BufferedReader;
import java.io.IOException;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

import keymanager.Key;

import nsmanager.NSBinding;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;

/**
 * Context class
 * 
 * 
 * @author mriya3
 *  
 */
public class Context {

	class ConnectionAttemptResultListener implements ExecutorCallbacksListener {

		public void dataAvailable(Executor ex, String request,
				BufferedReader response) {
			Document doc = null;
			try {
				/* Parse result */
				doc = (new SAXBuilder()).build(response);
			} catch (JDOMException e) {
				/* Async start */display.syncExec(new Runnable() {
					public void run() {
						ui.output.outputText(new StyleRange(),
								"\tCannot connect to <"
										+ session.getServerAddress() + ":"
										+ session.getServerPort() + ">\n",
								SWT.COLOR_RED, SWT.BOLD);
						isConnected = false;
						ui.setupNotConnectedActions();
						/* Async end */}
				});
				return;
			} catch (IOException e) {
				/* Async start */display.syncExec(new Runnable() {
					public void run() {
						ui.output.outputText(new StyleRange(),
								"\tCannot connect to <"
										+ session.getServerAddress() + ":"
										+ session.getServerPort() + ">\n",
								SWT.COLOR_RED, SWT.BOLD);
						isConnected = false;
						ui.setupNotConnectedActions();
						/* Async end */}
				});
				return;
			}
			Element rootNode = doc.getRootElement();
			String sid = rootNode.getAttributeValue("sessionId");
			if (sid == null) {
				if (display == null || display.isDisposed())
					return;
				/* Async start */display.syncExec(new Runnable() {
					public void run() {
						ui.output.outputText(new StyleRange(),
								"\tCannot login into <"
										+ session.getServerAddress() + ":"
										+ session.getServerPort() + ">\n",
								SWT.COLOR_RED, SWT.BOLD);
						isConnected = false;
						ui.setupNotConnectedActions();
						/* Async end */}
				});
				return;
			}
			session.setSessionId(sid);
			/* Async start */display.syncExec(new Runnable() {
				public void run() {
					isConnected = true;
					ui.setupConnectedActions();
					ui.output.setEditable(true);
					ui.getShell().setText(
							"roXanne Framework - Connected - x.click");
					ui.output.outputText(new StyleRange(), "\tConnected to <"
							+ session.getServerAddress() + ":"
							+ session.getServerPort() + ">\n", SWT.COLOR_GREEN,
							SWT.BOLD);
					ui.output
							.outputText(
									new StyleRange(),
									"\n\n\tUse <TAB> for auto completion ~ Use <TAB> on an empty line to get current context path\n",
									SWT.COLOR_DARK_YELLOW, SWT.NORMAL);
					ui.output.showPrompt();
					/* Async end */}
			});
		}

	}

	class LogoutAttemptResultListener implements ExecutorCallbacksListener {

		public void dataAvailable(Executor ex, String request,
				BufferedReader response) {
			Document doc = null;
			try {
				/* Parse result */
				doc = (new SAXBuilder()).build(response);
			} catch (JDOMException e) {
				/* Async start */display.syncExec(new Runnable() {
					public void run() {
						ui.output.outputText(new StyleRange(),
								"\tCannot talk to <"
										+ session.getServerAddress() + ":"
										+ session.getServerPort() + ">\n",
								SWT.COLOR_RED, SWT.BOLD);
						isConnected = false;
						ui.setupNotConnectedActions();
						/* Async end */}
				});
				return;
			} catch (IOException e) {
				/* Async start */display.syncExec(new Runnable() {
					public void run() {
						ui.output.outputText(new StyleRange(),
								"\tCannot talk to <"
										+ session.getServerAddress() + ":"
										+ session.getServerPort() + ">\n",
								SWT.COLOR_RED, SWT.BOLD);
						isConnected = false;
						ui.setupNotConnectedActions();
						/* Async end */}
				});
				return;
			}
			Element rootNode = doc.getRootElement();
			String sid = rootNode.getAttributeValue("sessionId");
			if (sid == null) {
				if (display == null || display.isDisposed())
					return;
				/* Async start */display.syncExec(new Runnable() {
					public void run() {
						ui.output.outputText(new StyleRange(),
								"\tCannot talk to <"
										+ session.getServerAddress() + ":"
										+ session.getServerPort() + ">\n",
								SWT.COLOR_RED, SWT.BOLD);
						isConnected = false;
						ui.setupNotConnectedActions();
						/* Async end */}
				});
				return;
			}
			session.setSessionId(sid);
			/* Async start */display.syncExec(new Runnable() {
				public void run() {
					isConnected = false;
					keys.clear();
					nsbindings.clear();
					ui.setupNotConnectedActions();
					ui.output.setEditable(false);
					ui.getShell().setText(
							"roXanne Framework - no session - x.click");
					ui.output.outputText(new StyleRange(),
							"\n\tLogged out from <"
									+ session.getServerAddress() + ":"
									+ session.getServerPort() + ">\n",
							SWT.COLOR_YELLOW, SWT.BOLD);

					/* Async end */}
			});
		}

	}

	class XPathResultListener implements ExecutorCallbacksListener {

		public void dataAvailable(Executor ex, String request,
				BufferedReader response) {
			Document doc = null;
			try {
				/* Parse result */
				doc = (new SAXBuilder()).build(response);
			} catch (JDOMException e) {
				/* Discard wrong data */
				/* Async start */display.syncExec(new Runnable() {
					public void run() {

						ui.setupConnectedActions();
						/* Async end */}
				});
				return;
			} catch (IOException e) {
				/* Async start */display.syncExec(new Runnable() {
					public void run() {

						ui.setupConnectedActions();
						/* Sync end */}
				});
				return;
			}
			try {
				clearWords();
				Element rootNode = doc.getRootElement();
				Element requests = rootNode.getChild("requests");
				Element action = requests.getChild("action");
				final String thecontext = action.getAttributeValue("context");
				final String depth = action.getAttributeValue("depth");
				final String selector = action.getAttributeValue("selector");
				/* Sync start */display.syncExec(new Runnable() {
					public void run() {
						ui.output.outputText(new StyleRange(), "\nXPath",
								SWT.COLOR_RED, SWT.BOLD);
						ui.output.appendText("\nDepth:\t\t\t\t\t\t" + depth);
						ui.output.appendText("\nContext:\t\t\t\t\t"
								+ thecontext);
						ui.output
								.appendText("\nSelector:\t\t\t\t\t" + selector);
						/* Sync end */}
				});

				addWord(thecontext);
				addWord(thecontext + selector);
				XMLOutputter op = new XMLOutputter(Format.getPrettyFormat());
				Iterator resultIterator = action.getChildren().iterator();
				while (resultIterator.hasNext()) {
					
					/* Sync start */display.syncExec(new Runnable() {
						public void run() {
							ui.output.outputText(new StyleRange(),
									"\n\nXPath::Result", SWT.COLOR_DARK_RED,
									SWT.BOLD);
							/* Sync end */}
					});
					Element result = (Element) resultIterator.next();
					String type = result.getAttributeValue("type");
					/* ***************************************************************** */
					if (type.equals("Element")) {

						/* Sync start */display.syncExec(new Runnable() {
							public void run() {
								ui.output
										.appendText("\nResult type:\t\t\t\tElement");
								/* Sync end */}
						});

						final String isInEncrypted = result
								.getAttributeValue("isInEncrypted");
						final String selfencrypted = result
								.getAttributeValue("isSelfEncrypted");
						final String hasText = result
								.getAttributeValue("hasText");
						final String relselector = result
								.getAttributeValue("selector");
						final String keyId = result.getAttributeValue("keyId");
						final String algo = result.getAttributeValue("method");
						String isReadonly;
						if (result.getAttributeValue("readonly") != null) {
							isReadonly = result.getAttributeValue("readonly");
						} else {
							isReadonly = "false";
						}
						final String readonly = isReadonly;

						boolean showEncProp = false;
						if (selfencrypted.equals("true")) {
							showEncProp = true;
						}

						final boolean showEnc = showEncProp;

						/* Sync start */display.syncExec(new Runnable() {
							public void run() {
								ui.output.appendText("\nIs in encrypted:\t\t\t"
										+ isInEncrypted);
								ui.output
										.appendText("\nIs self encrypted:\t\t\t"
												+ selfencrypted);
								ui.output.appendText("\nHas text:\t\t\t\t\t"
										+ hasText);
								ui.output
										.appendText("\nRelative XPath:\t\t\t\t"
												+ relselector);
								ui.output.appendText("\nReadonly:\t\t\t\t\t"
										+ readonly);
								if (showEnc) {
									ui.output.appendText("\nKey:\t\t\t\t\t\t"
											+ keyId);
									ui.output
											.appendText("\nMethod:\t\t\t\t\t\t"
													+ algo);
								}
								ui.output.appendText("\n\n");
								/* Sync end */}
						});

						addWord(relselector);
						addWord(thecontext + relselector);
						Iterator elementiterator = result.getChildren()
								.iterator();
						while (elementiterator.hasNext()) {
							final String data = op
									.outputString((Element) elementiterator
											.next());
							/* Sync start */display.syncExec(new Runnable() {
								public void run() {
									ui.output.appendText(data);
									/* Sync end */}
							});
						}
					}
					/* ***************************************************************** */
					else if (type.equals("Attribute")) {

						/* Sync start */display.syncExec(new Runnable() {
							public void run() {
								ui.output
										.appendText("\nResult type:\t\t\t\tAttribute");
								/* Sync end */}
						});

						final String isInEncrypted = result
								.getAttributeValue("isInEncrypted");
						final String relselector = result
								.getAttributeValue("selector");
						final String name = result.getAttributeValue("name");
						final String value = result.getAttributeValue("value");
						String isReadonly;
						if (result.getAttributeValue("readonly") != null) {
							isReadonly = result.getAttributeValue("readonly");
						} else {
							isReadonly = "false";
						}
						final String readonly = isReadonly;

						/* Sync start */display.syncExec(new Runnable() {
							public void run() {
								ui.output.appendText("\nIs in encrypted:\t\t\t"
										+ isInEncrypted);
								ui.output
										.appendText("\nRelative XPath:\t\t\t\t"
												+ relselector);
								ui.output.appendText("\nReadonly:\t\t\t\t\t"
										+ readonly);
								ui.output.appendText("\n\n");
								ui.output.appendText(name + "=\"" + value
										+ "\"");
								/* Sync end */}
						});

						addWord(relselector);
						addWord(thecontext + relselector);
					} else if (type.equals("Text")) {

						/* Sync start */display.syncExec(new Runnable() {
							public void run() {
								ui.output
										.appendText("\nResult type:\t\t\t\tText");
								/* Sync end */}
						});

						final String isInEncrypted = result
								.getAttributeValue("isInEncrypted");
						final String relselector = result
								.getAttributeValue("selector");
						final String text = result.getText();
						String isReadonly;
						if (result.getAttributeValue("readonly") != null) {
							isReadonly = result.getAttributeValue("readonly");
						} else {
							isReadonly = "false";
						}
						final String readonly = isReadonly;

						/* Sync start */display.syncExec(new Runnable() {
							public void run() {
								ui.output.appendText("\nIs in encrypted:\t\t\t"
										+ isInEncrypted);
								ui.output
										.appendText("\nRelative XPath:\t\t\t\t"
												+ relselector);
								ui.output.appendText("\nReadonly:\t\t\t\t\t"
										+ readonly);
								ui.output.appendText("\n\n");
								ui.output.appendText(text);
								/* Sync end */}
						});

						addWord(relselector);
						addWord(thecontext + relselector);

					}
				}
				

				
				setContextPath(thecontext);
				setSelector(selector);
				/*
				 * <requests> <action type="xpath" depth="2" context="/"
				 * selector="*"> <result type="Element" isInEncrypted="false"
				 * isEnvRoot="true" selector="database"> </result> </action>
				 */
			} catch (Exception e) {
				/* Sync start */display.asyncExec(new Runnable() {
					public void run() {
						ui.output.outputText(new StyleRange(),
								"\n\tInvalid XPath location", SWT.COLOR_RED,
								SWT.BOLD);
						/* Sync end */}
				});
				// e.printStackTrace();
			}
			/* Sync start */display.asyncExec(new Runnable() {
				public void run() {
					ui.setupConnectedActions();
					ui.output.showPrompt();
					/* Sync end */}
			});
		}

		/*
		 * (non-Javadoc)
		 * 
		 * @see application.ExecutorCallbacksListener#getUi()
		 */
		public UserInterface getUi() {
			return ui;
		}

	}

	private boolean isConnected = false;

	/* Used to provide asynchronous feedback through the terminal */
	Composite composite;

	Display display;

	ClientSession session;

	private UserInterface ui;

	/* Auto completion word list */
	private Vector words;

	/* Current context location */
	private String contextlocation = "/*";

	/* Current selector */
	private String selector = "";

	/* Namespace bindings vector */
	Vector nsbindings = new Vector();

	private Vector keys;
	
	/* Variables */
	private Hashtable variables = new Hashtable();

	/**
	 * Context class constructor. The user interface object must be provided
	 * 
	 * @param ui
	 */
	public Context(UserInterface ui) {
		this.ui = ui;
		composite = this.ui.getComposite();
		display = composite.getDisplay();
		words = new Vector();
		keys = new Vector();
	}

	/**
	 * Returns the display (used to provide asynchronous user feedback)
	 * 
	 * @return
	 */
	public Display getDisplay() {
		return display;
	}

	/**
	 * "Connects" to a server and creates a new session that can be used later
	 * to load keys an define namespaces
	 *  
	 */
	public void connect() {
		if (!isConnected) {
			/* Construct request */
			Document doc = new Document();
			Element rxq = new Element("roxannequery");
			doc.setRootElement(rxq);
			rxq.setAttribute("login", session.getLogin());
			rxq.setAttribute("password", session.getPassword());
			rxq.setAttribute("persistent", "true");
			if (!(session.getSessionId() == null))
				rxq.setAttribute("sessionId", session.getSessionId());
			XMLOutputter op = new XMLOutputter();
			String query = op.outputString(doc);
			Executor ex = new Executor(new ConnectionAttemptResultListener(),
					session);
			ex.setQuery(query);
			ex.start();
		}
	}

	/**
	 * Logout
	 *  
	 */
	public void logout() {
		if (isConnected) {
			/* Construct request */
			Document doc = new Document();
			Element rxq = new Element("roxannequery");
			doc.setRootElement(rxq);
			rxq.setAttribute("login", session.getLogin());
			rxq.setAttribute("password", session.getPassword());
			rxq.setAttribute("persistent", "false");
			if (!(session.getSessionId() == null))
				rxq.setAttribute("sessionId", session.getSessionId());
			XMLOutputter op = new XMLOutputter();
			String query = op.outputString(doc);
			Executor ex = new Executor(new LogoutAttemptResultListener(),
					session);
			ex.setQuery(query);
			ex.start();
		}
	}

	/**
	 * Executes an XPath search
	 * 
	 * @param xpath
	 */
	public void executeXPath(String xpath) {
		if (isConnected) {
			xpath.trim();
			/* Construct request */
			Document doc = new Document();
			Element rxq = new Element("roxannequery");
			doc.setRootElement(rxq);
			rxq.setAttribute("login", session.getLogin());
			rxq.setAttribute("password", session.getPassword());
			rxq.setAttribute("persistent", "true");
			if (!(session.getSessionId() == null))
				rxq.setAttribute("sessionId", session.getSessionId());
			Element requests = new Element("requests");
			rxq.addContent(requests);
			Element action = new Element("action");
			action.setAttribute("type", "xpath");
			String depth = getVariable("depth");
			if(depth==null)
				depth = "0";
			action.setAttribute("depth", depth);
			if (!(xpath.equals(""))) {
				if (xpath.substring(0, 1).equals("/"))
					action.setText(xpath);
				else
					action.setText(contextlocation + xpath);

				requests.addContent(action);
				XMLOutputter op = new XMLOutputter();
				String query = op.outputString(doc);
				Executor ex = new Executor(new XPathResultListener(), session);
				ex.setQuery(query);
				ui.output.setEditable(false);
				ui.setupWaitingReply();
				ex.start();
			}
		}
	}

	/**
	 * Returns the current session
	 * 
	 * @return
	 */
	public ClientSession getSession() {
		return this.session;
	}

	/**
	 * Renews a session by reloading keys and namespace declarations
	 *  
	 */
	public void renewSession() {
		// TODO: Necessary ?
	}

	/**
	 * Checks if a session renewal is needed, if so, does it
	 *  
	 */
	public void renewSessionIfNecessary() {
		// TODO: Necessary ?
	}

	/**
	 * Sets the session object to use
	 * 
	 * @param cs
	 */
	public void setSession(ClientSession cs) {
		this.session = cs;
	}

	/**
	 * Returns the autocompletion wordlist
	 * 
	 * @return
	 */
	public Vector getWordList() {
		return this.words;
	}

	/**
	 * Adds a word to the autocompletion list
	 * 
	 * @param word
	 */
	public void addWord(String word) {
		if (!(word == null) && !(words.contains(word)))
			words.add(word);
	}

	/**
	 * Clears the autocompletion wordlist
	 *  
	 */
	public void clearWords() {
		words.clear();
	}

	/**
	 * Returns the current context XPath
	 * 
	 * @return
	 */
	public String getContextPath() {
		return this.contextlocation;
	}

	/**
	 * Sets the context XPath
	 * 
	 * @param path
	 */
	public void setContextPath(String path) {
		this.contextlocation = path;
	}

	/**
	 * Returns the current selector
	 * 
	 * @return
	 */
	public String getSelector() {
		return this.selector;
	}

	/**
	 * Sets the current selector
	 * 
	 * @param selector
	 */
	public void setSelector(String selector) {
		this.selector = selector;
	}

	/**
	 * Returns current namespace bindings
	 * 
	 * @return
	 */
	public Vector getNSBindings() {
		return (Vector) nsbindings.clone();
	}

	/**
	 *  
	 */
	public void clearBindings() {
		nsbindings.clear();
	}

	/**
	 * @param nsbind
	 */
	public void addBinding(NSBinding nsbind) {
		nsbindings.add(nsbind);
	}

	/**
	 * @return
	 */
	public Vector getKeys() {
		return this.keys;
	}

	/**
	 * Adds or replaces a key to the list
	 * @param key
	 */
	public void addKey(Key key) {
		if (keys.contains(key))
			keys.remove(key);
		keys.add(key);
	}

	/**
	 * Removes a key from the list
	 * @param key
	 */
	public void removeKey(Key key) {
		if (keys.contains(key)) {
			keys.remove(key);
		}
	}
	
	/**
	 *  Sets a new variable 
	 */
	public void setVariable(String key, String value) {
		this.variables.put(key,value);
	}
	
	/**
	 * Gets a variable value
	 */
	public String getVariable(String key) {
		if(this.variables.containsKey(key))
			return (String) this.variables.get(key);
		else
			return null;
	}
	
	

	/**
	 * Returns the available encryption keys for the given method
	 * @param method
	 * @return
	 */
	public Vector getEncryptionKeys(String method) {
		Iterator keyIter = keys.iterator();
		Vector result = new Vector();
		while (keyIter.hasNext()) {
			Key tk = (Key) keyIter.next();
			if (tk.method.equals(method))
				if (tk.type.equals("encryption")) {
					result.add(tk.id);
				}
		}
		return result;

	}

}
