/**
Master Project WS-2004 ~ SS-2005, Computer Science

University of Fribourg, Information Systems Research Group (http://diuf.unifr.ch/is)

Student :    Amos Brocco <amos.brocco@unifr.ch>
Supervisors: Prof. Dr. Andreas Meier <andreas.meier@unifr.ch>
             Nicolas Werro <nicolas.werro@unifr.ch>
        __  __
 _ _ ___\ \/ /__ _ _ _  _ _  ___
| '_/ _ \>  </ _` | ' \| ' \/ -_)
|_| \___/_/\_\__,_|_||_|_||_\___|

roXanne, Secure XML Data Storage Framework
x.core & x.click Copyright (C) 2004-2005 Amos Brocco <amos.brocco@unifr.ch>
x.mill Copyright (C) 2004-2005 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

This product includes software developed by the JDOM Project (http://www.jdom.org/).
The Jaxup library is Copyright (c) 2001 - 2003 Erwin Bolwidt, used and modified under the BSD License.
Encryption modules used are Copyright (c) 2000 - 2004 The Legion Of The Bouncy Castle (http://www.bouncycastle.org).
JAXEN  is Copyright 2003 (C) The Werken Company. All Rights Reserved.
Base64 was released as Public Domain by its author Robert Harder (rob@iharder.net)
MySQL JDBC Connector is (c) 1995-2005 MySQL AB. All rights reserved. Released under the GNU/GPL License.
PostgreSQL JDBC Driver is Copyright (c) 2004-2005 The PostgreSQL Global Development Group, distributed under the BSD license
JArgs was created Steve Purcell, now mantained by Ewan Mellorby and released under the BSD licence.
**/

/*
 * Shows the namespace management window
 */
package keymanager;

import java.io.BufferedReader;
import java.io.IOException;
import java.util.Vector;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.Separator;
import org.eclipse.jface.action.ToolBarManager;
import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerSorter;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.ToolBar;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;

import wizards.addkey.AddKeyWizard;
import wizards.genkey.GenKeyWizard;
import application.Context;
import application.Executor;
import application.ExecutorCallbacksListener;

/**
 * Namespaces management window
 * 
 * @author mriya3
 *  
 */
public class ManageKeysDialog extends Dialog {

	Composite _composite;

	Context _context;

	private Vector keys;

	// **************************************************************
	// 				ACTIONS
	// **************************************************************

	/*
	 * Commit changes
	 */
	Action actionCommit = new Action("Done") {
		public void run() {
			disposeDialog();
		}
	};

	/*
	 * Delete the selected namespace binding
	 */
	Action actionRemoveKey = new Action("Remove key") {
		public void run() {
			int index = table.getSelectionIndex();
			if (index < 0)
				return;
			MessageBox messageBox = new MessageBox(shell, SWT.YES | SWT.NO);
			messageBox.setText("Confirmation");
			messageBox.setMessage("Are you sure to remove the selected key?");
			if (messageBox.open() == SWT.YES) {
				/* Removes the selected key */
				TableItem selected = table.getItem(table.getSelectionIndex());
				String id_toRemove = selected.getText(0);
				String method_toRemove = selected.getText(1);
				String type_toRemove = selected.getText(2);

				String query = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><roxannequery login=\""
						+ _context.getSession().getLogin()
						+ "\" password=\""
						+ _context.getSession().getPassword()
						+ "\" sessionId=\""
						+ _context.getSession().getSessionId()
						+ "\" persistent=\"true\"><keychain><removekey id=\""
						+ id_toRemove
						+ "\" method=\""
						+ method_toRemove
						+ "\" flag=\""
						+ type_toRemove
						+ "\"/></keychain></roxannequery>";

				Executor ex = new Executor(new RemoveKeyResultListener(),
						_context.getSession());
				ex.setQuery(query);
				ex.start();
			}
		}
	};

	class RemoveKeyResultListener implements ExecutorCallbacksListener {

		public void dataAvailable(Executor ex, final String request,
				BufferedReader response) {
			Document doc = null;
			try {
				/* Parse result */
				doc = (new SAXBuilder()).build(response);
			} catch (final JDOMException e) {
				/* Sync start */_context.getDisplay().syncExec(new Runnable() {
					public void run() {
						MessageBox messageBox = new MessageBox(shell, SWT.OK
								| SWT.ICON_WARNING);
						messageBox.setMessage("Cannot delete key!");
						messageBox.open();
						/* Sync end */}
				});
				return;
			} catch (final IOException e) {
				/* Sync start */_context.getDisplay().syncExec(new Runnable() {
					public void run() {
						MessageBox messageBox = new MessageBox(shell, SWT.OK
								| SWT.ICON_WARNING);
						messageBox.setMessage("Cannot delete key!");
						messageBox.open();
						/* Sync end */}
				});
				return;
			}

			/* Parse tree */
			Element rootNode = doc.getRootElement();
			Element keychain = rootNode.getChild("keychain");
			Element remkey = keychain.getChild("removekey");
			String encstatus = remkey.getAttributeValue("encryption");
			String decstatus = remkey.getAttributeValue("decryption");
			final String method = remkey.getAttributeValue("method");
			final String id = remkey.getAttributeValue("id");

			String nftype = null;

			if (encstatus == null && decstatus != null)
				nftype = "decryption";
			else if (encstatus != null && decstatus == null)
				nftype = "encryption";

			final String type = nftype;

			if ((encstatus == null || encstatus.equals("removed"))
					&& (decstatus == null || decstatus.equals("removed")))
				/* Sync start */_context.getDisplay().syncExec(new Runnable() {
					public void run() {
						Key rk = new Key();
						rk.id = id;
						rk.method = method;
						rk.type = type;
						_context.removeKey(rk);
						MessageBox messageBox = new MessageBox(shell, SWT.OK
								| SWT.ICON_INFORMATION);
						messageBox.setMessage("Key deleted!");
						messageBox.open();
						keys = _context.getKeys();
						tableViewer.setInput(keys);
						/* Sync end */}
				});
			else
				/* Sync start */_context.getDisplay().syncExec(new Runnable() {
					public void run() {
						MessageBox messageBox = new MessageBox(shell, SWT.OK
								| SWT.ICON_WARNING);
						messageBox.setMessage("Cannot delete key!");
						messageBox.open();
						/* Sync end */}
				});

		}
	}

	/*
	 * Load binding list from file
	 */
	Action actionAddKey = new Action("Add key") {
		public void run() {
			AddKeyWizard addkeywizard = new AddKeyWizard(_context);
			WizardDialog dialog = new WizardDialog(getShell(), addkeywizard);
			dialog.open();
			keys = _context.getKeys();
			tableViewer.setInput(keys);
		}
	};

	/*
	 * Save current binding list to file
	 */
	Action actionGenKey = new Action("Generate key") {
		public void run() {
			GenKeyWizard genkeywizard = new GenKeyWizard(_context);
			WizardDialog dialog = new WizardDialog(getShell(), genkeywizard);
			dialog.open();
		}
	};

	Vector bindings;

	private ToolBar bottomBar;

	private ToolBarManager bottomManager;

	String[] colNames = new String[] { "Id", "Method", "Type", "Source" };

	Display display;

	ToolBarManager manager;

	Table nstable;

	private Shell parent;

	Shell shell;

	Table table;

	TableViewer tableViewer;

	ToolBar toolBar;

	protected Object value;

	public ManageKeysDialog(Shell parent, Context ct) {
		super(parent);
		this._context = ct;
	}

	/**
	 * Sorter
	 */
	class KeysSorter extends ViewerSorter {
		private String property;

		private int propertyIndex;

		public KeysSorter(String sortByProperty) {
			for (int i = 0; i < colNames.length; i++) {
				if (colNames[i].equals(sortByProperty)) {
					this.property = sortByProperty;
					this.propertyIndex = i;
					return;
				}
			}
			throw new IllegalArgumentException("Unrecognized property: "
					+ sortByProperty);
		}
	}

	/**
	 * Creates the bottom toolbar (commit or cancel changes)
	 *  
	 */
	public void createBottomBar() {
		bottomBar = new ToolBar(shell, SWT.RIGHT | SWT.FLAT);
		bottomManager = new ToolBarManager(bottomBar);
		bottomManager.add(actionCommit);
		bottomManager.add(new Separator());
		bottomManager.update(true);
	}

	/**
	 * Creates main controls (a table)
	 *  
	 */
	public void createControls() {

		table = new Table(shell, SWT.BORDER | SWT.FULL_SELECTION);
		table.setLayoutData(new GridData(GridData.FILL_BOTH));
		table.setLinesVisible(true);
		table.setHeaderVisible(true);
		TableColumn id = new TableColumn(table, SWT.LEFT);
		id.setText(colNames[0]);
		id.setWidth(50);
		TableColumn method = new TableColumn(table, SWT.LEFT);
		method.setText(colNames[1]);
		method.setWidth(50);
		TableColumn type = new TableColumn(table, SWT.LEFT);
		type.setText(colNames[2]);
		type.setWidth(60);
		TableColumn source = new TableColumn(table, SWT.LEFT);
		source.setText(colNames[3]);
		source.setWidth(40);
		table.pack();
		shell.pack();

		tableViewer = new TableViewer(table);
		tableViewer.getTable().setLinesVisible(true);
		tableViewer.getTable().setHeaderVisible(true);
		tableViewer.getTable().setLayoutData(new GridData(GridData.FILL_BOTH));
		// Sets the content provider.
		tableViewer.setContentProvider(new IStructuredContentProvider() {

			public void dispose() {
			}

			public Object[] getElements(Object inputElement) {
				Vector v = (Vector) inputElement;
				return v.toArray();
			}

			public void inputChanged(Viewer viewer, Object oldInput,
					Object newInput) {
			}
		});
		// Sets the label provider.
		tableViewer.setLabelProvider(new ITableLabelProvider() {

			public void addListener(ILabelProviderListener listener) {
			}

			public void dispose() {
			}

			public Image getColumnImage(Object element, int columnIndex) {
				return null;
			}

			public String getColumnText(Object element, int columnIndex) {
				Key key = (Key) element;
				switch (columnIndex) {
				case 0:
					return key.id;
				case 1:
					return key.method;
				case 2:
					return key.type;
				case 3:
					return key.source;
				}
				return null;
			}

			public boolean isLabelProperty(Object element, String property) {
				return false;
			}

			public void removeListener(ILabelProviderListener listener) {
			}
		});

		tableViewer.setColumnProperties(colNames);

		// Setting sorters.
		id.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				tableViewer.setSorter(new KeysSorter(colNames[0]));
			}
		});
		method.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				tableViewer.setSorter(new KeysSorter(colNames[1]));
			}
		});

		type.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				tableViewer.setSorter(new KeysSorter(colNames[2]));
			}
		});

		source.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				tableViewer.setSorter(new KeysSorter(colNames[3]));
			}
		});

		/* Get key list from current context */
		keys = _context.getKeys();
		tableViewer.setInput(keys);

		shell.pack();
		shell.open();
	}

	/**
	 * Creates the toolbar (to add/remove/load and save bindings)
	 *  
	 */
	public void createToolbar() {
		toolBar = new ToolBar(shell, SWT.RIGHT | SWT.FLAT);
		manager = new ToolBarManager(toolBar);
		manager.add(actionAddKey);
		manager.add(actionGenKey);
		manager.add(new Separator());
		manager.add(actionRemoveKey);
		manager.update(true);
	}

	/**
	 * Disposes the wizard dialog
	 *  
	 */
	public void disposeDialog() {
		shell.dispose();
	}

	/**
	 * Namespace management dialog
	 */
	public int open() {
		parent = getParentShell();
		shell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
		shell.setText("Manage Keys");
		GridLayout gridLayout = new GridLayout();
		shell.setLayout(gridLayout);
		createToolbar();
		createControls();
		createBottomBar();
		shell.setMinimumSize(480, 380);
		shell.setSize(480, 380);
		shell.pack();
		shell.open();
		Rectangle shellBounds = parent.getBounds();
		Point dialogSize = shell.getSize();
		shell.setLocation(shellBounds.x + (shellBounds.width - dialogSize.x)
				/ 2, shellBounds.y + (shellBounds.height - dialogSize.y) / 2);
		display = shell.getDisplay();

		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		return 0;
	}

}
