/**
Master Project WS-2004 ~ SS-2005, Computer Science

University of Fribourg, Information Systems Research Group (http://diuf.unifr.ch/is)

Student :    Amos Brocco <amos.brocco@unifr.ch>
Supervisors: Prof. Dr. Andreas Meier <andreas.meier@unifr.ch>
             Nicolas Werro <nicolas.werro@unifr.ch>
        __  __
 _ _ ___\ \/ /__ _ _ _  _ _  ___
| '_/ _ \>  </ _` | ' \| ' \/ -_)
|_| \___/_/\_\__,_|_||_|_||_\___|

roXanne, Secure XML Data Storage Framework
x.core & x.click Copyright (C) 2004-2005 Amos Brocco <amos.brocco@unifr.ch>
x.mill Copyright (C) 2004-2005 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

This product includes software developed by the JDOM Project (http://www.jdom.org/).
The Jaxup library is Copyright (c) 2001 - 2003 Erwin Bolwidt, used and modified under the BSD License.
Encryption modules used are Copyright (c) 2000 - 2004 The Legion Of The Bouncy Castle (http://www.bouncycastle.org).
JAXEN  is Copyright 2003 (C) The Werken Company. All Rights Reserved.
Base64 was released as Public Domain by its author Robert Harder (rob@iharder.net)
MySQL JDBC Connector is (c) 1995-2005 MySQL AB. All rights reserved. Released under the GNU/GPL License.
PostgreSQL JDBC Driver is Copyright (c) 2004-2005 The PostgreSQL Global Development Group, distributed under the BSD license
JArgs was created Steve Purcell, now mantained by Ewan Mellorby and released under the BSD licence.
**/

/*
 * Shows the namespace management window
 */
package nsmanager;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Iterator;
import java.util.Vector;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.Separator;
import org.eclipse.jface.action.ToolBarManager;
import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.CheckboxCellEditor;
import org.eclipse.jface.viewers.ICellModifier;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TextCellEditor;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerSorter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Item;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.ToolBar;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.jdom.output.XMLOutputter;

import application.Context;
import application.Executor;
import application.ExecutorCallbacksListener;

/**
 * Namespaces management window
 * 
 * @author mriya3
 *  
 */
public class ManageNamespacesDialog extends Dialog {

	/*
	 * Sorter
	 */
	class BindSorter extends ViewerSorter {

		private int propertyIndex;
		private String property;

		public BindSorter(String sortByProperty) {
			for (int i = 0; i < colNames.length; i++) {
				if (colNames[i].equals(sortByProperty)) {
					this.property = sortByProperty;
					this.propertyIndex = i;
					return;
				}
			}
			throw new IllegalArgumentException("Unrecognized property: "
					+ sortByProperty);
		}

		/*
		 * (non-Javadoc)
		 * 
		 * @see org.eclipse.jface.viewers.ViewerSorter#compare(org.eclipse.jface.viewers.Viewer,
		 *      java.lang.Object, java.lang.Object)
		 */
		public int compare(Viewer viewer, Object e1, Object e2) {
			NSBinding bind1 = (NSBinding) e1;
			NSBinding bind2 = (NSBinding) e2;
			switch (propertyIndex) {
			case 0:
				return bind1.prefix.compareTo(bind2.prefix);
			case 1:
				return bind1.uri.compareTo(bind2.uri);
			default:
				return 0;
			}
		}

	}

	class NamespaceBindingsListener implements ExecutorCallbacksListener {

		public void dataAvailable(Executor ex, String request,
				BufferedReader response) {
			Document doc = null;
			try {
				/* Parse result */
				doc = (new SAXBuilder()).build(response);
			} catch (JDOMException e) {
				/* Async start */display.syncExec(new Runnable() {
					public void run() {
						MessageBox messageBox = new MessageBox(shell, SWT.OK);
						messageBox.setText("Error");
						messageBox
								.setMessage("Received invalid answer from server");
						messageBox.open();
						/* Async end */}
				});
				return;
			} catch (IOException e) {
				/* Async start */display.syncExec(new Runnable() {
					public void run() {
						MessageBox messageBox = new MessageBox(shell, SWT.OK);
						messageBox.setText("Error");
						messageBox
								.setMessage("Received invalid answer from server");
						messageBox.open();
						/* Async end */}
				});
				return;
			}
			Element rootNode = doc.getRootElement();
			String sid = rootNode.getAttributeValue("sessionId");
			Element requests = rootNode.getChild("requests");
			/* If sessionid is null the answer is not valid */
			if (sid == null) {
				if (display == null || display.isDisposed())
					return;
				/* Async start */display.syncExec(new Runnable() {
					public void run() {
						MessageBox messageBox = new MessageBox(shell, SWT.OK);
						messageBox.setText("Error");
						messageBox
								.setMessage("Received invalid answer from server");
						messageBox.open();
						/* Async end */}
				});
				return;
			}
			Iterator resultiter = requests.getChildren().iterator();
			while (resultiter.hasNext()) {
				Element action = (Element) resultiter.next();
				Element result = action.getChild("result");
				String type = action.getAttributeValue("type");
				String exitCode = result.getAttributeValue("exitCode");
				final String prefix = action.getAttributeValue("prefix");
				final String uri = action.getAttributeValue("uri");
				if (type.equals("nsunbindall") && (!(exitCode.equals("200")))) {
					/* Async start */display.syncExec(new Runnable() {
						public void run() {
							MessageBox messageBox = new MessageBox(shell,
									SWT.OK);
							messageBox.setText("Error");
							messageBox
									.setMessage("Cannot unbind previous namespaces bindings");
							messageBox.open();
							/* Async end */}
					});
				} else if (type.equals("nsunbindall")
						&& (exitCode.equals("200"))) {
					_context.clearBindings();
				} else if (type.equals("nsbind") && (exitCode.equals("200"))) {
					NSBinding nsbind = new NSBinding(prefix, uri);
					_context.addBinding(nsbind);
				} else if (type.equals("nsbind") && (!(exitCode.equals("200")))) {
					/* Async start */display.syncExec(new Runnable() {
						public void run() {
							MessageBox messageBox = new MessageBox(shell,
									SWT.OK);
							messageBox.setText("Error");
							messageBox
									.setMessage("Cannot bind namespace, prefix:"
											+ prefix + " uri:" + uri);
							messageBox.open();
							/* Async end */}
					});
				}
			}
			/* Async start */display.syncExec(new Runnable() {
				public void run() {
					MessageBox messageBox = new MessageBox(shell, SWT.OK);
					messageBox.setText("Done");
					messageBox.setMessage("All changes committed to server");
					messageBox.open();
					disposeDialog();
					/* Async end */}
			});
		}

	}

	Composite _composite;

	Context _context;

	// **************************************************************
	// 				ACTIONS
	// **************************************************************

	/*
	 * Creates a new namespace binding
	 */
	Action actionAddNew = new Action("New binding") {
		public void run() {
			//TableItem item = new TableItem(table, SWT.NULL);
			//table.select(table.getItemCount() - 1);
			NSBinding bind = new NSBinding("<prefix>", "<uri>");
			bindings.add(bind);
			tableViewer.refresh(false);
		}
	};

	Action actionCancel = new Action("Cancel") {
		public void run() {
			MessageBox messageBox = new MessageBox(shell, SWT.YES | SWT.NO);
			messageBox.setText("Cancel changes");
			messageBox.setMessage("Are you sure to cancel any changes made ?");
			if (messageBox.open() == SWT.YES) {
				shell.dispose();
			}
		}
	};

	/*
	 * Commit changes
	 */
	Action actionCommit = new Action("Commit changes") {
		public void run() {
			if (!(checkDuplicates())) {
				MessageBox messageBox = new MessageBox(shell, SWT.OK);
				messageBox.setText("Error");
				messageBox
						.setMessage("There are duplicate prefixes, cannot continue.");
				messageBox.open();
				return;
			}
			MessageBox messageBox = new MessageBox(shell, SWT.YES | SWT.NO);
			messageBox.setText("Commit changes to server");
			messageBox
					.setMessage("Are you sure to commit namespace bindings changes to server?");
			if (messageBox.open() == SWT.YES) {
				Executor ex = new Executor(new NamespaceBindingsListener(),
						_context.getSession());
				/* Construct request */
				Document doc = new Document();
				Element rxq = new Element("roxannequery");
				doc.setRootElement(rxq);
				rxq.setAttribute("login", _context.getSession().getLogin());
				rxq.setAttribute("password", _context.getSession()
						.getPassword());
				rxq.setAttribute("persistent", "true");
				if (!(_context.getSession().getSessionId() == null))
					rxq.setAttribute("sessionId", _context.getSession()
							.getSessionId());
				Element requests = new Element("requests");
				rxq.addContent(requests);
				Element action = new Element("action");
				action.setAttribute("type", "nsunbindall");
				requests.addContent(action);
				for (int i = 0; i < table.getItemCount(); i++) {
					TableItem item = table.getItem(i);
					String prefix = item.getText(0);
					String uri = item.getText(1);
					Element bindaction = new Element("action");
					bindaction.setAttribute("type", "nsbind");
					bindaction.setAttribute("prefix", prefix);
					bindaction.setAttribute("uri", uri);
					requests.addContent(bindaction);
				}
				XMLOutputter op = new XMLOutputter();
				String query = op.outputString(doc);
				ex.setQuery(query);
				ex.start();
			}
		}
	};

	/*
	 * Delete the selected namespace binding
	 */
	Action actionDelete = new Action("Remove selected") {
		public void run() {
			int index = table.getSelectionIndex();
			if (index < 0)
				return;
			MessageBox messageBox = new MessageBox(shell, SWT.YES | SWT.NO);
			messageBox.setText("Confirmation");
			messageBox
					.setMessage("Are you sure to remove the binding with prefix "
							+ table.getItem(index).getText(0)
							+ " ?\n(Changes will be effective when you press the Commit button)");
			if (messageBox.open() == SWT.YES) {
				table.remove(index);
			}
		}
	};

	/*
	 * Load binding list from file
	 */
	Action actionLoad = new Action("Load from file") {
		public void run() {
			loadBindings();
		}
	};

	/*
	 * Save current binding list to file
	 */
	Action actionSave = new Action("Save to file") {
		public void run() {
			saveBindings();
		}
	};

	Vector bindings;

	private ToolBar bottomBar;

	private ToolBarManager bottomManager;

	String[] colNames = new String[] { "Prefix", "URI" };

	Display display;

	ToolBarManager manager;

	Table nstable;

	private Shell parent;

	Shell shell;

	Table table;

	TableViewer tableViewer;

	ToolBar toolBar;

	protected Object value;

	public ManageNamespacesDialog(Shell parent, Context ct) {
		super(parent);
		this._context = ct;
	}

	/*
	 * Checks if there are duplicate namespace definitions
	 */
	public boolean checkDuplicates() {
		Vector prefixes = new Vector();
		for (int i = 0; i < table.getItemCount(); i++) {
			TableItem item = table.getItem(i);
			String prefix = item.getText(0);
			if (!(prefixes.contains(prefix)))
				prefixes.add(prefix);
			else
				return false;
		}
		return true;
	}

	/*
	 * Creates the bottom toolbar (commit or cancel changes)
	 *  
	 */
	public void createBottomBar() {
		bottomBar = new ToolBar(shell, SWT.RIGHT | SWT.FLAT);
		bottomManager = new ToolBarManager(bottomBar);
		bottomManager.add(actionCommit);
		bottomManager.add(new Separator());
		bottomManager.add(actionCancel);
		bottomManager.update(true);
	}

	/*
	 * Creates main controls (a table)
	 *  
	 */
	public void createControls() {
		table = new Table(shell, SWT.BORDER | SWT.FULL_SELECTION);
		table.setLayoutData(new GridData(GridData.FILL_BOTH));
		table.setLinesVisible(true);
		table.setHeaderVisible(true);
		TableColumn prefix = new TableColumn(table, SWT.LEFT);
		prefix.setText(colNames[0]);
		TableColumn uri = new TableColumn(table, SWT.NULL);
		uri.setText(colNames[1]);
		prefix.setWidth(100);
		uri.setWidth(360);
		table.pack();
		shell.pack();

		tableViewer = new TableViewer(table);
		tableViewer.getTable().setLinesVisible(true);
		tableViewer.getTable().setHeaderVisible(true);
		tableViewer.getTable().setLayoutData(new GridData(GridData.FILL_BOTH));
		// Sets the content provider.
		tableViewer.setContentProvider(new IStructuredContentProvider() {

			public void dispose() {
			}

			public Object[] getElements(Object inputElement) {
				Vector v = (Vector) inputElement;
				return v.toArray();
			}

			public void inputChanged(Viewer viewer, Object oldInput,
					Object newInput) {
			}
		});
		// Sets the label provider.
		tableViewer.setLabelProvider(new ITableLabelProvider() {

			public void addListener(ILabelProviderListener listener) {
			}

			public void dispose() {
			}

			public Image getColumnImage(Object element, int columnIndex) {
				return null;
			}

			public String getColumnText(Object element, int columnIndex) {
				NSBinding bind = (NSBinding) element;
				switch (columnIndex) {
				case 0:
					return bind.prefix;
				case 1:
					return bind.uri;
				}
				return null;
			}

			public boolean isLabelProperty(Object element, String property) {
				return false;
			}

			public void removeListener(ILabelProviderListener listener) {
			}
		});

		// Sets cell editors
		tableViewer.setColumnProperties(colNames);
		CellEditor[] cellEditors = new CellEditor[4];
		cellEditors[0] = new TextCellEditor(table);
		cellEditors[1] = cellEditors[0];
		cellEditors[2] = cellEditors[0];
		cellEditors[3] = new CheckboxCellEditor(table);
		tableViewer.setCellEditors(cellEditors);
		tableViewer.setCellModifier(new ICellModifier() {
			public boolean canModify(Object element, String property) {
				return true;
			}

			public Object getValue(Object element, String property) {
				// Get the index first.
				int index = -1;
				for (int i = 0; i < colNames.length; i++) {
					if (colNames[i].equals(property)) {
						index = i;
						break;
					}
				}
				NSBinding bind = (NSBinding) element;
				switch (index) {
				case 0:
					return bind.prefix;
				case 1:
					return bind.uri;
				}
				return null;
			}

			public void modify(Object element, String property, Object value) {
				int index = -1;
				for (int i = 0; i < colNames.length; i++) {
					if (colNames[i].equals(property)) {
						index = i;
						break;
					}
				}
				NSBinding bind = null;
				if (element instanceof Item) {
					TableItem item = (TableItem) element;
					bind = (NSBinding) item.getData();
				} else {
					bind = (NSBinding) element;
				}
				switch (index) {
				case 0:
					bind.prefix = (String) value;
					break;
				case 1:
					bind.uri = (String) value;
					break;
				}
				tableViewer.update(bind, null);
			}
		});
		// Setting sorters.
		prefix.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				tableViewer.setSorter(new BindSorter(colNames[0]));
			}
		});
		uri.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				tableViewer.setSorter(new BindSorter(colNames[1]));
			}
		});

		/* Get bindings from current context */
		bindings = _context.getNSBindings();
		tableViewer.setInput(bindings);

		shell.pack();
		shell.open();
	}

	/**
	 * Creates the toolbar (to add/remove/load and save bindings)
	 *  
	 */
	public void createToolbar() {
		toolBar = new ToolBar(shell, SWT.RIGHT | SWT.FLAT);
		manager = new ToolBarManager(toolBar);
		manager.add(actionAddNew);
		manager.add(actionDelete);
		manager.add(new Separator());
		manager.add(actionSave);
		manager.add(actionLoad);
		manager.update(true);
	}

	/**
	 * Disposes the wizard dialog
	 *  
	 */
	public void disposeDialog() {
		shell.dispose();
	}

	/*
	 * Load binding list form file
	 */
	private void loadBindings() {
		DataInputStream in = null;
		try {

			FileDialog fd = new FileDialog(shell, SWT.OPEN);
			fd.setText("Load bindings from file");
			fd.setFilterPath(System.getProperty("os.path"));
			String[] filterExt = { "*.rxb", "*.*" };
			fd.setFilterExtensions(filterExt);
			String selected = fd.open();

			File file = new File(selected);
			if (!file.exists())
				return;
			in = new DataInputStream(new FileInputStream(file));

			while (true) {
				String prefix = in.readUTF();
				String uri = in.readUTF();
				TableItem item = new TableItem(table, SWT.NULL);

				item.setText(new String[] { prefix, uri });
			}

		} catch (IOException ioe) {
		} finally {
			try {
				if (in != null)
					in.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	/**
	 * Namespace management dialog
	 */
	public int open() {
		parent = getParentShell();
		shell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
		shell.setText("Manage Namespace bindings");
		GridLayout gridLayout = new GridLayout();
		shell.setLayout(gridLayout);
		createToolbar();
		createControls();
		createBottomBar();
		shell.setMinimumSize(480, 380);
		shell.pack();
		shell.open();
		Rectangle shellBounds = parent.getBounds();
		Point dialogSize = shell.getSize();
		shell.setLocation(shellBounds.x + (shellBounds.width - dialogSize.x)
				/ 2, shellBounds.y + (shellBounds.height - dialogSize.y) / 2);
		display = shell.getDisplay();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		return 0;
	}

	/*
	 * Save binding list to file
	 */
	private void saveBindings() {
		DataOutputStream out = null;
		try {

			FileDialog fd = new FileDialog(shell, SWT.SAVE);
			fd.setText("Save bindings to file");
			fd.setFilterPath(System.getProperty("os.path"));
			String[] filterExt = { "*.rxb", "*.*" };
			fd.setFilterExtensions(filterExt);
			String selected = fd.open();
			File file = new File(selected);

			out = new DataOutputStream(new FileOutputStream(file));

			for (int i = 0; i < table.getItemCount(); i++) {
				TableItem item = table.getItem(i);
				out.writeUTF(item.getText(0));
				out.writeUTF(item.getText(1));
			}
		} catch (IOException ioe) {
			// Ignore.
		} finally {
			try {
				if (out != null)
					out.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}
