/**
Master Project WS-2004 ~ SS 2005, Computer Science

University of Fribourg, Information Systems Research Group (http://diuf.unifr.ch/is)

Student :    Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>
Supervisors: Prof. Dr. Andreas Meier <andreas.meier@unifr.ch>
             Nicolas Werro <nicolas.werro@unifr.ch>
        __  __
 _ _ ___\ \/ /__ _ _ _  _ _  ___
| '_/ _ \>  </ _` | ' \| ' \/ -_)
|_| \___/_/\_\__,_|_||_|_||_\___|

roXanne, Secure XML Data Storage Framework
x.core & x.click Copyright (C) 2004-2005 Amos Brocco <amos.brocco@unifr.ch>
x.mill Copyright (C) 2004-2005 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

This product includes software developed by the JDOM Project (http://www.jdom.org/).
The Jaxup library is Copyright (c) 2001 - 2003 Erwin Bolwidt, used and modified under the BSD License.
Encryption modules used are Copyright (c) 2000 - 2004 The Legion Of The Bouncy Castle (http://www.bouncycastle.org).
JAXEN  is Copyright 2003 (C) The Werken Company. All Rights Reserved.
Base64 was released as Public Domain by its author Robert Harder (rob@iharder.net)
MySQL JDBC Connector is (c) 1995-2005 MySQL AB. All rights reserved. Released under the GNU/GPL License.
PostgreSQL JDBC Driver is Copyright (c) 2004-2005 The PostgreSQL Global Development Group, distributed under the BSD license
JArgs was created Steve Purcell, now mantained by Ewan Mellorby and released under the BSD licence.
**/


//Generazione file XML per PostgreSQL
package support;

import java.io.IOException;
import java.io.StringWriter;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Properties;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Text;
import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

import com.sun.org.apache.xml.internal.serialize.OutputFormat;
import com.sun.org.apache.xml.internal.serialize.XMLSerializer;

//import java.io.*;

public class ImportFromPostgreSQL implements ImportInterface {

	Statement stat = null;

	Connection conn = null;

	DocumentBuilderFactory dbf;

	DocumentBuilder db;

	Document document;

	String tableName = null;

	DatabaseMetaData dbmd = null;

	ResultSet casb = null;

	
	ResultSetMetaData md = null;

	String port;

	boolean getInformationDb;

	
	Vector tablesToExportStructure = new Vector();

	Vector tablesToExportData = new Vector();

	boolean continueOnError;

	boolean continueOnTableNotFound = false;

	boolean continueOnDatabaseNotFound = false;

	boolean continueOnErrorGeneral = false;
	private String resultXML;

	Properties prop = new java.util.Properties();

	/*
	 * 
	 * Creates new node with fonction appendNodeWithName
	 */

	private String serveraddress;

	private String database;

	private Text log;

	private static Node appendNodeWithName(Node parent, String nomenodo,
			String valeur1) throws Exception {
		valeur1 = stringToHTMLString(valeur1);
		nomenodo = stringToHTMLString(nomenodo);
		Element element = parent.getOwnerDocument().createElement(nomenodo);
		
		element.setAttribute("name", valeur1);
		parent.appendChild(element);
		return element;

	}

	/*
	 * Creates new node with fonction appendNodeWithAttribute
	 */
	private static Node appendNodeWithAttribute(Node parent, String nomenodo,
			String nomeattributo, String valore)
			throws Exception {
		nomeattributo = stringToHTMLString(nomeattributo);
		valore = stringToHTMLString(valore);
		nomenodo = stringToHTMLString(nomenodo);
		
		Element element = parent.getOwnerDocument().createElement(nomenodo);
		
		element.setAttribute(nomeattributo, valore);
		parent.appendChild(element);
		return element;

	}

	private static Node appendNodes(Node parent, String nomenodo) throws Exception{

		Element element = parent.getOwnerDocument().createElement(nomenodo);

		parent.appendChild(element);
		return element;
	}

	private static String affichage(Node N, int profondeur) throws Exception {
		String ret = "";
		Node fils;
		if (N != null) {
			if (N.hasChildNodes()) {
				//Premier enfant
				fils = N.getFirstChild();
				while (fils != null) {
					//ici le traitement sp�cifique
					ret += "\n";
					for (int i = 0; i <= profondeur; i++)
						ret += "\t";
					//Pour recuperer la valeur d'un attribut :
					ret += ((Element) fils).getAttribute("name") + " "
							+ ((Element) fils).getAttribute("texte");

					//récurrence : affiche les enfants de fils.
					ret += affichage(fils, profondeur + 1);
					//Passe au fr�re suivant
					fils = fils.getNextSibling();
				}
			}
		}
		return ret;
	}

	private void doExportData() throws Exception{
		
		
		InitDataTree(database);
		//	  	Serialize DOM
		OutputFormat format = new OutputFormat(document);
		//		 as a String
		StringWriter stringOut = new StringWriter();
		XMLSerializer serial = new XMLSerializer(stringOut, format);
		try {
			serial.serialize(document);
		} catch (IOException e) {
			if (continueOnErrorGeneral)
				printError("Error reading XML: \n"+e.getMessage());
			else
				throw new Exception("Error reading XML: \n"+e.getMessage());
		}
		//		 Display the XML
		resultXML = stringOut.toString();
	}

	private void printError(String error) throws Exception {
		final String theerror = error;
		if(!(log==null)) {
		/* Sync start */Display.getCurrent().syncExec(new Runnable() {
			public void run() {
				log.append(theerror+" \n");
			}});
		}
		//throw new Exception(theerror);
	}
	
	
	
	private void printMessage(String message) throws Exception {
		final String themessage = message;
		if(!(log==null)) {
		/* Sync start */Display.getCurrent().syncExec(new Runnable() {
			public void run() {
				log.append(themessage+"\n");
			}});
		}
	}
	
	
	public void setLogText(Text log) {
		this.log = log;
	}

	/**
	 * 
	 * @param url
	 * @param prop
	 */
	private void initConnection(String url, Properties prop) throws Exception{
		try {
			// Register MySQL driver
			Class.forName("org.postgresql.Driver").newInstance();

			if(!(conn==null))
				conn.close();
			// Open a properties file where connection info is store
			conn = DriverManager.getConnection(url, prop);

			stat = conn.createStatement();
		} catch (Exception ex) {
			ex.printStackTrace();
			if (continueOnErrorGeneral)
				printError("Error connecting databases:\n"+ex.getMessage());
			else
				throw new Exception("Error connection databases:\n"+ex.getMessage());
		}

	}

	private void InitDataTree(String database) throws Exception{
		printMessage("Initialisation XML tree");
		dbf = DocumentBuilderFactory.newInstance();
		try {
			db = dbf.newDocumentBuilder();
		} catch (ParserConfigurationException e) {
			if (continueOnErrorGeneral)
				printError("Error creating tree:\n"+e.getMessage());
			else
				throw new Exception("Error creating tree:\n"+e.getMessage());
		}
		document = db.newDocument();

		//creé un Node racine

		Node racine = document.createElement("database");
		

		((Element) racine).setAttribute("name", database);



		//et l'ajoute au document...
		document.appendChild(racine);
		processChildRoot(racine);

	}

	/**
	 * List databases PostgreSQL
	 * 
	 * @return
	 */

	public Vector listDatabase() throws Exception{
		Vector listData = new Vector();

		try {
			casb = stat
					.executeQuery("SELECT datname FROM pg_database WHERE datname !~ '^template';");

			while (casb.next()) {

				listData.add(casb.getString(1));
			}

		} catch (SQLException e) {
			if (continueOnErrorGeneral)
				printError("Error list database, problem connection:\n"+e.getMessage());
			else
				throw new Exception("Error list database, problem connection:\n"+e.getMessage());
		}
	
		return listData;
		
	}

	/**
	 * Select database
	 */
	public boolean selectDatabase(String database)throws Exception {

		initConnection("jdbc:postgresql://" + serveraddress + ":" + port + "/"
				+ database, this.prop);
		this.database = database;
		return true;
		
	}

	/**
	 * Return liste table database
	 */

	public Vector listTables() throws Exception{

		Vector listTab = new Vector();
		try {
			dbmd = conn.getMetaData();
		} catch (SQLException e) {
			printError("Error string SQL:\n"+e.getMessage());
			e.printStackTrace();
		}
		// Specify the type of object; in this case we want tables
		String[] types = { "TABLE" };

		ResultSet resultSet = null;
		try {
			resultSet = dbmd.getTables("", "", "%", types);
		} catch (SQLException e1) {
			if (continueOnErrorGeneral)
				printError("Error list tables, databases not found:\n"+e1.getMessage());
			else
				throw new Exception("Error list tables, databases not found:\n"+e1.getMessage());
			
		}

		try {
			while (resultSet.next()) {
				// Get the table name
				tableName = resultSet.getString(3);
				listTab.add(new String(tableName));
				
			}
			
		} catch (SQLException e2) {
			if (continueOnErrorGeneral)
				printError("Error list tables, databases not found:\n"+e2.getMessage());
			else
				throw new Exception("Error list tables, databases not found:\n"+e2.getMessage());
		
		}
		
		return listTab;
	}

	/**
	 * 
	 * 
	 * @param racine
	 * 
	 * 
	 * 
	 * <database name="agenzia"> - * <tables name="table"> </tables>- * <DbInfos
	 * name="informationDbDataType"> </DbInfos> </database>
	 *  
	 */
	private void processChildRoot(Node racine) throws Exception{
		printMessage("Processing root children");
		Node noeudTab = appendNodes(racine, "tables");
		Node noeudInfoDbDataType = appendNodes(racine, "dbInfos");
		processChildTables(noeudTab);
		processNodeDataType(noeudInfoDbDataType);

	}

	/**
	 * 
	 * @param noeudTab
	 * 
	 * 
	 * 
	 * 
	 * 
	 * <database name="agenzia"> - * <tables name="table"> <tableName name="t1">
	 * </tableName>
	 * 
	 * <tableName name="t2"> </tableName>
	 * 
	 * <tableName name="t3"> </tableName>
	 * 
	 * <tableName name="tn"> </tableName> </tables>- * <DbInfos
	 * name="informationDbDataType"> </DbInfos> </database>
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 *  
	 */

	private void processChildTables(Node noeudTab)throws Exception {
		printMessage("Processing tables");
		try {
			dbmd = conn.getMetaData();
		} catch (SQLException e) {
			printError("Error string SQL:\n"+e.getMessage());
		}
		// Specify the type of object; in this case we want tables
		String[] types = { "TABLE" };

		ResultSet resultSet = null;
		try {
			resultSet = dbmd.getTables("", "", "%", types);
		} catch (SQLException e1) {
			printError("Error string SQL:\n"+e1.getMessage());
			if (continueOnErrorGeneral)
				printError("Error creating tree:\n"+e1.getMessage());
			else
				throw new Exception("Error creating tree:\n"+e1.getMessage());
		}

		try {
			while (resultSet.next()) {
				// Get the table name
				tableName = resultSet.getString(3);
				if ((tablesToExportData.contains(tableName))
						|| (tablesToExportStructure.contains(tableName))) {
					Node noeudNomiTab = appendNodeWithName(noeudTab,
							"tableName", tableName);
					printMessage("Processing table: "+tableName);
					processNodeInformationField(noeudNomiTab, tableName);
				}
							}
			listTables();
			listDatabase();
		
		} catch (SQLException e2) {
			printError("Error string SQL:\n"+e2.getMessage());
			if (continueOnErrorGeneral)
				printError("Error string SQL:\n"+e2.getMessage());
			else
				throw new Exception("Error string SQL:\n"+e2.getMessage());
		}

	}

	/**
	 * 
	 * @param noeudNomiTab
	 * 
	 * 
	 * 
	 * <database name="agenzia"> - * <tables name="table"> <tableName name="t1">
	 * <information name="informatioField" </information> <entries
	 * name="EntriesTable"> </entries> </tableName>
	 * 
	 * <tableName name="t2"> <information name="informatioField" </information>
	 * <entries name="EntriesTable"> </entries> </tableName>
	 * 
	 * <tableName name="t3"> <information name="informatioField" </information>
	 * <entries name="EntriesTable"> </entries> </tableName>
	 * 
	 * <tableName name="tn">
	 * 
	 * <information name="informatioField" </information> <entries
	 * name="EntriesTable"> </entries> </tableName> </tables>- * <DbInfos
	 * name="informationDbDataType"> </DbInfos> </database>
	 * 
	 * 
	 * 
	 * 
	 *  
	 */
	private void processNodeInformationField(Node noeudNomiTab, String tableName)throws Exception {
		printMessage("Processing information field node");
		if (tablesToExportStructure.contains(tableName)) {
			Node noeudCol = appendNodes(noeudNomiTab, "information");
			processNodeColumn(noeudCol);
		}
		if (tablesToExportData.contains(tableName)) {
			Node noeudEntries = appendNodes(noeudNomiTab, "entries");
			processNodeData(noeudEntries);
		}

	}

	/**
	 * 
	 * @param noeudEntries
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 * <database name="agenzia"> - * <tables name="table"> <tableName name="t1">
	 * <information name="informatioField" </information> <entries
	 * name="EntriesTable"> <entry name="t1"> <data ...="..."/> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/> <data
	 * ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="t2"> <information name="informatioField" </information>
	 * <entries name="EntriesTable"> <entry name="t2"> <data ...="..."/> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> </entry> </entries>
	 * </tableName>
	 * 
	 * <tableName name="t3"> <information name="informatioField" </information>
	 * <entries name="EntriesTable"> <entry name="t3"> <data ...="..."/> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> </entry> </entries>
	 * </tableName>
	 * 
	 * <tableName name="tn"> <information name="informatioField" </information>
	 * <entries name="EntriesTable">
	 * 
	 * <entry name="tn"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName> </tables> <DbInfos
	 * name="informationDbDataType"> </DbInfos> </database>
	 * 
	 *  
	 */
	private void processNodeData(Node noeudEntries)throws Exception {
		printMessage("Processing data node");
		try {
			casb = stat.executeQuery("SELECT * FROM " + tableName);
			md = casb.getMetaData();
			while (casb.next())

			{
				Node noeudColEnt = appendNodes(noeudEntries, "entry");

				int noCols = 0;
				try {
					noCols = casb.getMetaData().getColumnCount();
				} catch (SQLException e1) {
					if (continueOnTableNotFound)
						printError("Error table not found:\n"+e1.getMessage());
					else
						throw new Exception("Error table not found:\n"+e1.getMessage());
				}
				for (int i = 1; i <= noCols; ++i) {

					Element element = noeudEntries.getOwnerDocument()
							.createElement("data");
					try {
						element.setAttribute("id", stringToHTMLString(md
								.getColumnName(i)));
						element.setAttribute("value", stringToHTMLString(casb
								.getObject(i).toString()));
					} catch (DOMException e) {
						if (continueOnTableNotFound)
							printError("Error table not found:\n"+e.getMessage());
						else
							throw new Exception("Error table not found:\n"+e.getMessage());
					} catch (SQLException e) {
						if (continueOnTableNotFound)
							printError("Error table not found:\n"+e.getMessage());
						else
							throw new Exception("Error table not found:\n"+e.getMessage());
					}
					noeudColEnt.appendChild(element);

				}
			}
		} catch (DOMException e) {
			if (continueOnTableNotFound)
				printError("Error table not found:\n"+e.getMessage());
			else
				throw new Exception("Error table not found:\n"+e.getMessage());
		} catch (SQLException e) {
			if (continueOnTableNotFound)
				printError("Error table not found:\n"+e.getMessage());
			else
				throw new Exception("Error table not found:\n"+e.getMessage());
		}
	}

	/**
	 * 
	 * @param noeudCol
	 * 
	 * 
	 * 
	 * 
	 * <database name="agenzia"> - * <tables name="table"> <tableName name="t1">
	 * <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> </Column> <Column IsAutoIncrement="..." IsNullable="..."
	 * Size="..." Type="..." name="..."> </Column>
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t1"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/> <data
	 * ...="..."/> <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="t2"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * </Column> <Column IsAutoIncrement="..." IsNullable="..." Size="..."
	 * Type="..." name="..."> </Column>
	 * 
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t2"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * </entry> </entries> </tableName>
	 * 
	 * <tableName name="t3"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * </Column> <Column IsAutoIncrement="..." IsNullable="..." Size="..."
	 * Type="..." name="..."> </Column> </information> <entries
	 * name="EntriesTable"> <entry name="t3"> <data ...="..."/> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> </entry> </entries>
	 * </tableName>
	 * 
	 * <tableName name="tn"> <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> </Column> <Column IsAutoIncrement="..." IsNullable="..."
	 * Size="..." Type="..." name="..."> </Column> </information> <entries
	 * name="EntriesTable">
	 * 
	 * <entry name="tn"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName> </tables> <DbInfos
	 * name="informationDbDataType"> </DbInfos> </database>
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 *  
	 */
	private void processNodeColumn(Node noeudCol) throws Exception{
		printMessage("Processing column from table " +tableName);
		try {
			casb = stat.executeQuery("SELECT * FROM " + tableName);
		} catch (SQLException e) {
			if (continueOnTableNotFound)
				printError("Error table not found:\n"+e.getMessage() );
			else
				throw new Exception("Error table not found:\n"+e.getMessage() );
		}

		try {
			md = casb.getMetaData();
		} catch (SQLException e1) {
			if (continueOnTableNotFound)
				printError("Error table not found:\n"+e1.getMessage());
			else
				throw new Exception("Error table not found:\n"+e1.getMessage());
		}

		int numeroColonne = 0;
		try {
			numeroColonne = casb.getMetaData().getColumnCount();
		} catch (SQLException e7) {
			if (continueOnTableNotFound)
				printError("Error table not found:\n"+e7.getMessage());
			else
				throw new Exception("Error table not found:\n"+e7.getMessage());
		}

		for (int a = 1; a <= numeroColonne; a++) {

			printError("");

			Node noeudNomeCol = null;

			try {
				noeudNomeCol = appendNodeWithName(noeudCol, "column", md
						.getColumnName(a));
			} catch (SQLException e6) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e6.getMessage());
				else
					throw new Exception("Error table not found:\n"+e6.getMessage());
			}
			try {
				((Element) noeudNomeCol).setAttribute("type", md
						.getColumnTypeName(a));
			} catch (DOMException e5) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e5.getMessage());
				else
					throw new Exception("Error table not found:\n"+e5.getMessage());
			} catch (SQLException e5) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e5.getMessage());
				else
					throw new Exception("Error table not found:\n"+e5.getMessage());
			}
			try {
				((Element) noeudNomeCol).setAttribute("size", Integer
						.toString(md.getColumnDisplaySize(a)));
			} catch (DOMException e4) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e4.getMessage());
				else
					throw new Exception("Error table not found:\n"+e4.getMessage());
			} catch (SQLException e4) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e4.getMessage());
				else
					throw new Exception("Error table not found:\n"+e4.getMessage());
			}
			try {
				((Element) noeudNomeCol).setAttribute("isAutoIncrement",
						Boolean.toString(md.isAutoIncrement(a)));
			} catch (DOMException e8) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e8.getMessage());
				else
					throw new Exception("Error table not found:\n"+e8.getMessage());
			} catch (SQLException e8) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e8.getMessage());
				else
					throw new Exception("Error table not found:\n"+e8.getMessage());
			}
			try {
				String nullable = "";
				int val = md.isNullable(a);
				if (val == ResultSetMetaData.columnNoNulls) {
					nullable = "no";
				} else if (val == ResultSetMetaData.columnNullable) {
					nullable = "true";
				} else if (val == ResultSetMetaData.columnNullableUnknown) {
					nullable = "unknown";
				}

				((Element) noeudNomeCol).setAttribute("isNullable", Integer
						.toString(md.isNullable(a)));
			} catch (DOMException e3) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e3.getMessage());
				else
					throw new Exception("Error table not found:\n"+e3.getMessage());
			} catch (SQLException e3) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e3.getMessage());
				else
					throw new Exception("Error table not found:\n"+e3.getMessage());
			}

			ResultSet primaria = null;
			try {
				primaria = dbmd.getPrimaryKeys("", "", tableName);
			} catch (SQLException e) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e.getMessage());
				else
					throw new Exception("Error table not found:\n"+e.getMessage());
			}

			try {
				while (primaria.next()) {

					if (primaria.getString("COLUMN_NAME").equals(
							md.getColumnName(a)))

						((Element) noeudNomeCol).setAttribute("primaryKey",
								"true");
				}
			} catch (SQLException e1) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e1.getMessage());
				else
					throw new Exception("Error table not found:\n"+e1.getMessage());
			}

		}
	}

	private void processNodePrimaryKeys(Node noeudNomeCol)throws Exception {
		printMessage("Processing primary key node");
		ResultSet primaria = null;
		try {
			primaria = dbmd.getPrimaryKeys(null, null, tableName);
		} catch (SQLException e) {
			if (continueOnTableNotFound)
				printError("Error table not found:\n"+e.getMessage());
			else
				throw new Exception("Error table not found:\n"+e.getMessage());
		}

		try {
			while (primaria.next()) {

				Node noeudInfoChiavi = appendNodeWithName(noeudNomeCol,
						"Primary_Keys", primaria.getString("COLUMN_NAME"));
			}
		} catch (SQLException e1) {
			if (continueOnTableNotFound)
				printError("Error table not found:\n"+e1.getMessage());
			else
				throw new Exception("Error table not found:\n"+e1.getMessage());
		}

	}

	/**
	 * 
	 * @param noeudInfoDbDataType
	 * 
	 * 
	 * 
	 * 
	 * <database name="agenzia"> - * <tables name="table"> <tableName name="t1">
	 * <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="id_casa"/> </Column>
	 * 
	 * 
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="id_casa"/> </Column>
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t1"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/> <data
	 * ...="..."/> <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="t2"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="id_casa"/> </Column> <Column IsAutoIncrement="..."
	 * IsNullable="..." Size="..." Type="..." name="..."> <Primary_Keys
	 * name="id_casa"/> </Column>
	 * 
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t2"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * </entry> </entries> </tableName>
	 * 
	 * <tableName name="t3"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="id_casa"/> </Column> <Column IsAutoIncrement="..."
	 * IsNullable="..." Size="..." Type="..." name="..."> <Primary_Keys
	 * name="id_casa"/> </Column> </information> <entries name="EntriesTable">
	 * <entry name="t3"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="tn"> <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="id_casa"/> </Column> <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="id_casa"/> </Column> </information> <entries
	 * name="EntriesTable">
	 * 
	 * <entry name="tn"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName> </tables> <DbInfos
	 * name="informationDbDataType"> <dataType name="type"> </dataType>
	 * </DbInfos> </database>
	 * 
	 * 
	 * 
	 * 
	 * 
	 *  
	 */
	private void processNodeDataType(Node noeudInfoDbDataType) throws Exception{
		printMessage("Processing data type node");
		Node noeudDataType = appendNodes(noeudInfoDbDataType, "dataType");

		if (getInformationDb) {
			processNodeNumericType(noeudDataType);
			processNodeDataTimeType(noeudDataType);
			processNodeStringType(noeudDataType);
			processNodeMonetaryType(noeudDataType);
			processNodeBinaryType(noeudDataType);
			processNodeBooleanType(noeudDataType);
			processNodeGeometricType(noeudDataType);
			processNodeNetworkAddressType(noeudDataType);

		} else
			return;

	}

	/**
	 * 
	 * Numeric type
	 * 
	 * @param noeudDataType
	 * 
	 * 
	 * <database name="agenzia"> - * <tables name="table"> <tableName name="t1">
	 * <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="id_casa"/> </Column>
	 * 
	 * 
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="id_casa"/> </Column>
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t1"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/> <data
	 * ...="..."/> <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="t2"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="id_casa"/> </Column> <Column IsAutoIncrement="..."
	 * IsNullable="..." Size="..." Type="..." name="..."> <Primary_Keys
	 * name="id_casa"/> </Column>
	 * 
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t2"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * </entry> </entries> </tableName>
	 * 
	 * <tableName name="t3"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="id_casa"/> </Column> <Column IsAutoIncrement="..."
	 * IsNullable="..." Size="..." Type="..." name="..."> <Primary_Keys
	 * name="id_casa"/> </Column> </information> <entries name="EntriesTable">
	 * <entry name="t3"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="tn"> <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="id_casa"/> </Column> <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="id_casa"/> </Column> </information> <entries
	 * name="EntriesTable">
	 * 
	 * <entry name="tn"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName> </tables> <DbInfos
	 * name="informationDbDataType"> <dataType name="type"> <typeClass
	 * name="numericType"> <type_Name bytes="..." max_value="..."
	 * min_value="..." name="..."/> <typeName bytes="..." max_value="..."
	 * min_value="..." name="..."/> <typeName bytes="..." max_value="..."
	 * min_value="..." name="..."/> <typeName bytes="..." max_value="..."
	 * min_value="..." name="..."/>
	 * 
	 * <typeName name="..."/>
	 * 
	 * </typeClass </dataType> </DbInfos> </database>
	 * 
	 * 
	 * 
	 *  
	 */
	private void processNodeNumericType(Node noeudDataType)throws Exception {
		printMessage("Processing numeric type node");
		Node noeudNumericType = appendNodeWithName(noeudDataType, "typeClass",
				"numeric");

		/*
		 * smallint
		 */

		Node noeudSmallint = appendNodeWithName(noeudNumericType, "typeName",
				"smallint");
		((Element) noeudSmallint).setAttribute("bytes", "2");
		((Element) noeudSmallint).setAttribute("min_value", "-32768");
		((Element) noeudSmallint).setAttribute("max_value", "32767");
		/*
		 * integer
		 */
		Node noeudInteger = appendNodeWithName(noeudNumericType, "typeName",
				"integer");
		((Element) noeudInteger).setAttribute("bytes", "4");
		((Element) noeudInteger).setAttribute("min_value", "-2147483648");
		((Element) noeudInteger).setAttribute("max_value", "2147483647");

		/*
		 * bigint
		 */
		Node noeudBigint = appendNodeWithName(noeudNumericType, "typeName",
				"bigint");
		((Element) noeudBigint).setAttribute("bytes", "8");
		((Element) noeudBigint).setAttribute("min_value",
				"-9223372036854775808");
		((Element) noeudBigint).setAttribute("max_value",
				"-9223372036854775807");

		/*
		 * type decimal
		 */
		Node noeudDecimal = appendNodeWithName(noeudNumericType, "typeName",
				"decimal");
		((Element) noeudDecimal).setAttribute("bytes", "variable");
		((Element) noeudDecimal).setAttribute("min_value", "no_limit");
		((Element) noeudDecimal).setAttribute("max_value", "no_limit");

		/*
		 * type numeric
		 */
		Node noeudNumeric = appendNodeWithName(noeudNumericType, "typeName",
				"numeric");
		((Element) noeudNumeric).setAttribute("bytes", "variable");
		((Element) noeudNumeric).setAttribute("min_value", "no_limit");
		((Element) noeudNumeric).setAttribute("max_value", "no_limit");

		/*
		 * type real
		 */
		Node noeudReal = appendNodeWithName(noeudNumericType, "typeName",
				"real");
		((Element) noeudReal).setAttribute("bytes", "4");
		((Element) noeudReal).setAttribute("min_value",
				"6 decimal digits precision");
		((Element) noeudReal).setAttribute("max_value",
				"6 decimal digits precision");

		/*
		 * type double_precision
		 */
		Node noeudDouble_precision = appendNodeWithName(noeudNumericType,
				"typeName", "double_precision");
		((Element) noeudDouble_precision).setAttribute("bytes", "8");
		((Element) noeudDouble_precision).setAttribute("min_value",
				"15 decimal digits precision");
		((Element) noeudDouble_precision).setAttribute("max_value",
				"15 decimal digits precision");

		/*
		 * type serial
		 */
		Node noeudSerial = appendNodeWithName(noeudNumericType, "typeName",
				"serial");
		((Element) noeudSerial).setAttribute("bytes", "4");
		((Element) noeudSerial).setAttribute("min_value", "1");
		((Element) noeudSerial).setAttribute("max_value", "2147483647");

		/*
		 * type bigserial
		 */
		Node noeudBigSerial = appendNodeWithName(noeudNumericType, "typeName",
				"bigserial");
		((Element) noeudBigSerial).setAttribute("bytes", "8");
		((Element) noeudBigSerial).setAttribute("min_value", "1");
		((Element) noeudBigSerial).setAttribute("max_value",
				"9223372036854775807");

	
		/*
		 * zerofill
		 */
		Node noeudZerofill = appendNodeWithName(noeudNumericType, "typeName",
				"zerofill");

	}

	/**
	 * String data and time type
	 * 
	 * @param noeudDataType
	 *  * <database name="agenzia"> - * <tables name="table">
	 * <tableName name="t1"> <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="..."/> </Column>
	 * 
	 * 
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="..."/> </Column>
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t1"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/> <data
	 * ...="..."/> <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="t2"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="..."/> </Column> <Column IsAutoIncrement="..."
	 * IsNullable="..." Size="..." Type="..." name="..."> <Primary_Keys
	 * name="..."/> </Column>
	 * 
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t2"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * </entry> </entries> </tableName>
	 * 
	 * <tableName name="t3"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="..."/> </Column> <Column IsAutoIncrement="..."
	 * IsNullable="..." Size="..." Type="..." name="..."> <Primary_Keys
	 * name="..."/> </Column> </information> <entries name="EntriesTable">
	 * <entry name="t3"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="tn"> <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="..."/> </Column> <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="..."/> </Column> </information> <entries
	 * name="EntriesTable">
	 * 
	 * <entry name="tn"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName> </tables> <DbInfos
	 * name="informationDbDataType"> <dataType name="type"> <typeClass
	 * name="numericType"> <type_Name bytes="..." max_value="..."
	 * min_value="..." name="..."/> <typeName bytes="..." max_value="..."
	 * min_value="..." name="..."/> <typeName bytes="..." max_value="..."
	 * min_value="..." name="..."/> <typeName bytes="..." max_value="..."
	 * min_value="..." name="..."/>
	 * 
	 * <typeName name="..."/>
	 * 
	 * </typeClass> <typeClass name="dataAndTimeType"> <typeName format="... to
	 * ..." name="..."/> <Type_Name format="... to ..." name="..."/> <typeName
	 * name="..."/>
	 * 
	 * </typeClass> </dataType> </DbInfos> </database>
	 * 
	 * 
	 * 
	 * 
	 *  
	 */
	private void processNodeDataTimeType(Node noeudDataType)throws Exception {
		printMessage("Processing data and time type node");
		Node noeudDataTimeType = appendNodeWithName(noeudDataType, "typeClass",
				"dataAndTime");

		/*
		 * timestamp without time zone
		 */

		Node noeudTimestampWithoutTimeZone = appendNodeWithName(
				noeudDataTimeType, "typeName", "timestamp_without_time_zone");
		((Element) noeudTimestampWithoutTimeZone).setAttribute("bytes", "8");
		((Element) noeudTimestampWithoutTimeZone).setAttribute("format",
				"4713BC to 5874897AD");

		/*
		 * timestamp with time zone
		 */
		Node noeudTimestampWithTimeZone = appendNodeWithName(noeudDataTimeType,
				"typeName", "timestamp_with_time_zone");
		((Element) noeudTimestampWithTimeZone).setAttribute("bytes", "8");
		((Element) noeudTimestampWithTimeZone).setAttribute("format",
				"4713BC to 5874897AD");

		/*
		 * type interval
		 */
		Node noeudInterval = appendNodeWithName(noeudDataTimeType, "typeName",
				"interval");
		((Element) noeudInterval).setAttribute("bytes", "12");
		((Element) noeudInterval).setAttribute("format",
				"-178000000 years to 178000000 years");

		/*
		 * type date
		 */
		Node noeudDate = appendNodeWithName(noeudDataTimeType, "typeName",
				"date");
		((Element) noeudDate).setAttribute("bytes", "4");
		((Element) noeudDate).setAttribute("format", "4713BC to 32767AD");

		/*
		 * type time without time zone
		 */
		Node noeudTimeWithoutTimeZone = appendNodeWithName(noeudDataTimeType,
				"typeName", "time_without_time_zone");
		((Element) noeudTimeWithoutTimeZone).setAttribute("bytes", "8");
		((Element) noeudTimeWithoutTimeZone).setAttribute("format",
				"00:00:00:00 to 23:59:59:99");

		/*
		 * type time with time zone
		 */
		Node noeudTimeWithTimeZone = appendNodeWithName(noeudDataTimeType,
				"typeName", "time_with_time_zone");
		((Element) noeudTimeWithTimeZone).setAttribute("bytes", "8");
		((Element) noeudTimeWithTimeZone).setAttribute("format",
				"00:00:00:00+12 to 23:59:59:99-12");

	}

	/**
	 * String type
	 * 
	 * @param noeudDataType
	 *  * <database name="agenzia"> - * <tables name="table">
	 * <tableName name="t1"> <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="..."/> </Column>
	 * 
	 * 
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="..."/> </Column>
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t1"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/> <data
	 * ...="..."/> <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="t2"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="..."/> </Column> <Column IsAutoIncrement="..."
	 * IsNullable="..." Size="..." Type="..." name="..."> <Primary_Keys
	 * name="..."/> </Column>
	 * 
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t2"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * </entry> </entries> </tableName>
	 * 
	 * <tableName name="t3"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="..."/> </Column> <Column IsAutoIncrement="..."
	 * IsNullable="..." Size="..." Type="..." name="..."> <Primary_Keys
	 * name="..."/> </Column> </information> <entries name="EntriesTable">
	 * <entry name="t3"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="tn"> <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="..."/> </Column> <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="..."/> </Column> </information> <entries
	 * name="EntriesTable">
	 * 
	 * <entry name="tn"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName> </tables> <DbInfos
	 * name="informationDbDataType"> <dataType name="type"> <typeClass
	 * name="numericType"> <type_Name bytes="..." max_value="..."
	 * min_value="..." name="..."/> <typeName bytes="..." max_value="..."
	 * min_value="..." name="..."/> <typeName bytes="..." max_value="..."
	 * min_value="..." name="..."/> <typeName bytes="..." max_value="..."
	 * min_value="..." name="..."/>
	 * 
	 * <typeName name="..."/>
	 * 
	 * </typeClass <typeClass name="dataAndTimeType"> <typeName format="... to
	 * ..." name="..."/> <type_Name format="... to ..." name="..."/> <typeName
	 * name="..."/>
	 * 
	 * </typeClass> <typeClass name="stringType"> <typeName bytes="..."
	 * max_value="..." min_value="..." name="..."/>
	 * 
	 * <typeName name="..."/>
	 * 
	 * <typeName bytes="..." max_value="..." min_value="..." name="..."/>
	 * 
	 * <typeName name="..."/>
	 * 
	 * </typeClass </dataType> </DbInfos> </database>
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 *  
	 */
	private void processNodeStringType(Node noeudDataType) throws Exception{
		printMessage("Processing node string type node");
		Node noeudStringType = appendNodeWithName(noeudDataType, "typeClass",
				"string");

		/*
		 * type character_varying(n)
		 */

		Node noeudCharacterVarying = appendNodeWithName(noeudStringType,
				"typeName", "character_varying(n)");
		((Element) noeudCharacterVarying).setAttribute("description",
				"variable-length with limit");

		/*
		 * type varchar(n)
		 */
		Node noeudVarchar = appendNodeWithName(noeudStringType, "typeName",
				"varchar(n)");
		((Element) noeudVarchar).setAttribute("description",
				"variable-length with limit");

		/*
		 * type character(n)
		 */
		Node noeudCharacter = appendNodeWithName(noeudStringType, "typeName",
				"character(n)");
		((Element) noeudCharacter).setAttribute("description",
				"fixed-length, blank padded");

		/*
		 * type char(n)
		 */
		Node noeudChar = appendNodeWithName(noeudStringType, "typeName",
				"char(n)");
		((Element) noeudChar).setAttribute("description",
				"fixed-length, blank padded");
		/*
		 * type text
		 */
		Node noeudText = appendNodeWithName(noeudStringType, "typeName", "text");
		((Element) noeudText).setAttribute("description",
				"variable unlimited length");

	}

	/**
	 * Monetary type
	 * 
	 * @param noeudDataType
	 */

	private void processNodeMonetaryType(Node noeudDataType) throws Exception{
		printMessage("Processing monetary type node");
		Node noeudMonetaryType = appendNodeWithName(noeudDataType, "typeClass",
				"monetary");
		Node noeudMoney = appendNodeWithName(noeudMonetaryType, "typeName",
				"money");
		((Element) noeudMoney).setAttribute("bytes", "4");
		((Element) noeudMoney).setAttribute("max_value", "-21474836.48");
		((Element) noeudMoney).setAttribute("min_value", "21474836.47");
	}

	/**
	 * Geometric type
	 * 
	 * @param noeudDataType
	 */
	private void processNodeGeometricType(Node noeudDataType)throws Exception {
		printMessage("Processing geometric type node");
		Node noeudGeometricType = appendNodeWithName(noeudDataType,
				"typeClass", "geometric");

		Node noeudPoint = appendNodeWithName(noeudGeometricType, "typeName",
				"point");
		((Element) noeudPoint).setAttribute("bytes", "16");
		((Element) noeudPoint).setAttribute("description", "(x,y)");

		Node noeudLine = appendNodeWithName(noeudGeometricType, "typeName",
				"line");
		((Element) noeudLine).setAttribute("bytes", "32");
		((Element) noeudLine).setAttribute("description",
				"Infinite line (x1,y1),(x2,y2)");

		Node noeudLseg = appendNodeWithName(noeudGeometricType, "typeName",
				"lseg");
		((Element) noeudLseg).setAttribute("bytes", "32");
		((Element) noeudLseg).setAttribute("description",
				"Finite line (x1,y1),(x2,y2)");

		Node noeudBox = appendNodeWithName(noeudGeometricType, "typeName",
				"box");
		((Element) noeudBox).setAttribute("bytes", "32");
		((Element) noeudBox).setAttribute("description",
				"Rectangular (x1,y1),(x2,y2)");

		Node noeudPath = appendNodeWithName(noeudGeometricType, "typeName",
				"path");
		((Element) noeudPath).setAttribute("bytes", "16+16n");
		((Element) noeudPath).setAttribute("description",
				"Closed path ((x1,y1),...)");

		Node noeudPath1 = appendNodeWithName(noeudGeometricType, "typeName",
				"path1");
		((Element) noeudPath1).setAttribute("bytes", "16+16n");
		((Element) noeudPath1).setAttribute("description",
				"Open path ((x1,y1),...)");

		Node noeudPolygon = appendNodeWithName(noeudGeometricType, "typeName",
				"polygon");
		((Element) noeudPolygon).setAttribute("bytes", "40+16n");
		((Element) noeudPolygon).setAttribute("description", " ((x1,y1),...)");

		Node noeudCircle = appendNodeWithName(noeudGeometricType, "typeName",
				"circle");
		((Element) noeudCircle).setAttribute("bytes", "24");
		((Element) noeudCircle).setAttribute("description", "<(x,y),r>");

	}

	/**
	 * Binary type
	 * 
	 * @param noeudDataType
	 */
	private void processNodeBinaryType(Node noeudDataType)throws Exception {
		printMessage("Processing binary type node");
		Node noeudBinaryType = appendNodeWithName(noeudDataType, "typeClass",
				"binary");
		Node noeudBytea = appendNodeWithName(noeudBinaryType, "typeName",
				"bytea");
		((Element) noeudBytea).setAttribute("bytes", "4");
		((Element) noeudBytea).setAttribute("description",
				"variable-length binary string");
	}

	/**
	 * Boolean type
	 * 
	 * @param noeudDataType
	 */

	private void processNodeBooleanType(Node noeudDataType)throws Exception {
		printMessage("Processing boolean type node");
		Node noeudBooleanType = appendNodeWithName(noeudDataType, "typeClass",
				"boolean");

		Node noeudT = appendNodeWithName(noeudBooleanType, "typeName", "true");
		((Element) noeudT).setAttribute("true", "t, true, y, yes, 1");

		Node noeudF = appendNodeWithName(noeudBooleanType, "typeName", "false");
		((Element) noeudF).setAttribute("false", "f, false, n, no, 0");
	}

	/**
	 * NetworkAdress
	 * 
	 * @param noeudDataType
	 */

	private void processNodeNetworkAddressType(Node noeudDataType)throws Exception {
		printMessage("Processing network address type node");
		Node noeudNetworkAddressType = appendNodeWithName(noeudDataType,
				"typeClass", "network_address");
		Node noeudCidr = appendNodeWithName(noeudNetworkAddressType,
				"typeName", "cidr");
		((Element) noeudCidr).setAttribute("bytes", "12 or 24");
		((Element) noeudCidr).setAttribute("description",
				"IPv4 or IPv6 networks");

		Node noeudInet = appendNodeWithName(noeudNetworkAddressType,
				"typeName", "inet");
		((Element) noeudInet).setAttribute("bytes", "12 or 24");
		((Element) noeudInet).setAttribute("description",
				"IPv4 or IPv6 host and networks");

		Node noeudMacaddr = appendNodeWithName(noeudNetworkAddressType,
				"typeName", "macaddr");
		((Element) noeudMacaddr).setAttribute("bytes", "6");
		((Element) noeudMacaddr).setAttribute("description", "MAC address");
	}

	private static String stringToHTMLString(String string) throws Exception{
		StringBuffer sb = new StringBuffer(string.length());
		// true if last char was blank
		boolean lastWasBlankChar = false;
		int len = string.length();
		char c;

		for (int i = 0; i < len; i++) {
			c = string.charAt(i);
			if (c == ' ') {
				// blank gets extra work,
				// this solves the problem you get if you replace all
				// blanks with &nbsp;, if you do that you loss
				// word breaking
				if (lastWasBlankChar) {
					lastWasBlankChar = false;
					sb.append("&nbsp;");
				} else {
					lastWasBlankChar = true;
					sb.append(' ');
				}
			} else {
				lastWasBlankChar = false;
				//
				// HTML Special Chars
				if (c == '"')
					sb.append("&quot;");
				else if (c == '&')
					sb.append("&amp;");
				else if (c == '<')
					sb.append("&lt;");
				else if (c == '>')
					sb.append("&gt;");
				else if (c == '\n')
					// Handle Newline
					sb.append("&lt;br/&gt;");
				else {
					int ci = 0xffff & c;
					if (ci < 160)
						// nothing special only 7 Bit
						sb.append(c);
					else {
						// Not 7 Bit use the unicode system
						sb.append("&#");
						sb.append(new Integer(ci).toString());
						sb.append(';');
					}
				}
			}
		}
		return sb.toString();
	}

	/**
	 * (non-Javadoc)
	 * 
	 * @see migration.ImportInterface#initConnection(java.lang.String,
	 *      java.lang.String, java.lang.String, java.lang.String)
	 */
	public void initConnection(String serveraddress, String serverport,
			String defaultdb, String username, String password) throws Exception{

		this.prop.put("user", username);
		if (!(password.equals("")))
			this.prop.put("password", password);
		this.prop.put("useUnicode", "true");
		this.serveraddress = serveraddress;
		this.port = serverport;
		if (defaultdb.equals(""))
			defaultdb = "template1";

		initConnection("jdbc:postgresql://" + serveraddress + ":" + port + "/"
				+ defaultdb, prop);

	}

	/**
	 * @see migration.ImportInterface#setTablesToExportData(java.util.Vector)
	 */
	public void setTablesToExportData(Vector tables) {
		this.tablesToExportData = tables;

	}

	/**
	 * @see migration.ImportInterface#setTablesToExportStructure(java.util.Vector)
	 */
	public void setTablesToExportStructure(Vector tables) {
		this.tablesToExportStructure = tables;

	}
	
	
	
	public void setContinueOnDatabaseNotFound() {
		this.continueOnDatabaseNotFound = true;
	}
	/**
	 * 
	 */
	
	public void setContinueOnErrorGeneral() {
		this.continueOnErrorGeneral = true;
	}
	/**
	 * @see migration.ImportInterface#setContinueOnTableNotFound()
	 */
	public void setContinueOnTableNotFound() {
		this.continueOnTableNotFound = true;

	}

	/**
	 * @see migration.ImportInterface#setInformationDatabaseExport()
	 */
	public void setInformationDatabaseExport() {
		this.getInformationDb = true;
	}

	/**
	 * @see migration.ImportInterface#exportData()
	 */
	public String exportData() throws Exception{
		doExportData();
		return resultXML;
	}
	
	public void forceCloseConnection() {
		try {
			conn.close();
			printMessage("Done closing connection");
		} catch (Exception e) {
			try {
				printError("Error closing connection to database:\n"+e.getMessage());
			} catch (Exception e1) {
			}
		}
	}
}
