/**
Master Project WS-2004 ~ SS 2005, Computer Science

University of Fribourg, Information Systems Research Group (http://diuf.unifr.ch/is)

Student :    Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>
Supervisors: Prof. Dr. Andreas Meier <andreas.meier@unifr.ch>
             Nicolas Werro <nicolas.werro@unifr.ch>
        __  __
 _ _ ___\ \/ /__ _ _ _  _ _  ___
| '_/ _ \>  </ _` | ' \| ' \/ -_)
|_| \___/_/\_\__,_|_||_|_||_\___|

roXanne, Secure XML Data Storage Framework
x.core & x.click Copyright (C) 2004-2005 Amos Brocco <amos.brocco@unifr.ch>
x.mill Copyright (C) 2004-2005 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

This product includes software developed by the JDOM Project (http://www.jdom.org/).
The Jaxup library is Copyright (c) 2001 - 2003 Erwin Bolwidt, used and modified under the BSD License.
Encryption modules used are Copyright (c) 2000 - 2004 The Legion Of The Bouncy Castle (http://www.bouncycastle.org).
JAXEN  is Copyright 2003 (C) The Werken Company. All Rights Reserved.
Base64 was released as Public Domain by its author Robert Harder (rob@iharder.net)
MySQL JDBC Connector is (c) 1995-2005 MySQL AB. All rights reserved. Released under the GNU/GPL License.
PostgreSQL JDBC Driver is Copyright (c) 2004-2005 The PostgreSQL Global Development Group, distributed under the BSD license
JArgs was created Steve Purcell, now mantained by Ewan Mellorby and released under the BSD licence.
**/

package support;

import java.io.StringReader;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Iterator;
import java.util.Properties;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Text;
import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

import com.sun.org.apache.xerces.internal.impl.xs.dom.DOMParser;

/**
 * @author ghigo
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */

public class XMLMySQLImporter implements ExportInterface {

	/* Node name constants */
	private static final String DATABASENODE = "database";

	private static final String DATABASEINFONODE = "dbInfos";

	private static final String DATABASEINFODATATYPE = "dataType";

	private static final String DATABASEINFOTYPECLASS = "typeClass";

	private static final String DATABASEINFOTYPENAME = "typeName";

	private static final String ENTRIESNODE = "entries";

	private static final String INFORMATIONODE = "information";

	private static final String TABLESNODE = "tables";

	private static final String DATANODE = "data";

	private static final String PRIMARYKEYS = "primaryKeys";

	private static final String ENTRYNODE = "entry";

	private static final String COLUMNNODE = "column";

	private static final String PRIMARYKEYNODE = "primary";

	private static final String STRUCTURENODE = "tableName";

	/* Other global variables */
	private Statement stat = null;
	
	private Properties prop;

	Connection conn = null;

	Vector tables = null;

	private Properties DatabaseProperties;

	private Properties ImportProperties;

	String NomeDatabase = "";

	String NomeTabella;

	String use = "";
	
	Text log;

	Vector primaryKeys = new Vector();

	int numberTables = 0;

	String ColType = "";

	String ColSize = "";

	String nomeColonne;

	String ColIsAutoIncremental = "";

	String IsNullable = "";

	String PrimaryAtt = "";

	String IsPrimaryKeyY = "";

	String ColIsNullable = "";

	Vector valueData = new Vector();

	Vector listeColumn = new Vector();

	String primaryKey = "";

	Vector sqlInstruction = new Vector();

	Vector sqlIntroduction = new Vector();

	String isPrimaryKeyY = "";

	String pkey = "";

	Vector listPrimaryKeys = new Vector();
	boolean continueOnErrorGeneral = false;

	private String source;

	private String databaseName;
	/**
	 * Initializes the database connection
	 * 
	 * @param url
	 * @param prop
	 */
	private void initConnection(String url, Properties prop)throws Exception {
		try {
			
			/* 
			 * Register MySQL driver
			 */
			Class.forName("com.mysql.jdbc.Driver").newInstance();
			/* 
			 * Open a properties file where connection info is store
			 */
			conn = DriverManager.getConnection(url, prop);
			/* 
			 * Initialisation
			 */
			stat = conn.createStatement();
		} catch (Exception ex) {
			if (continueOnErrorGeneral)
				printError("Error connecting databases "+ex.getLocalizedMessage());
			else
				throw new Exception("Error connecting databases "+ex.getLocalizedMessage());
		}
	}

	
	
	
	private void printError(String error) throws Exception {
		final String theerror = error;
		if(!(log==null)) {
		/* Sync start */Display.getCurrent().syncExec(new Runnable() {
			public void run() {
				log.append("Error: "+ theerror+" \n");
			}});
		}
	}
	
	
	private void printMessage(String message) throws Exception {
		final String themessage = message;
		if(!(log==null)) {
		/* Sync start */Display.getCurrent().syncExec(new Runnable() {
			public void run() {
				log.append(themessage+"\n");
			}});
		}
	}
	
	public void initConnection(String serveraddress, String serverport,
			String defaultdb, String username, String password) throws Exception{
		prop = new java.util.Properties();
		prop.put("user", username);
		if (!(password.equals("")))
			prop.put("password", password);
		prop.put("useUnicode", "true");

		if (defaultdb.equals(""))
			defaultdb = "";
		initConnection("jdbc:mysql://" + serveraddress + ":" + serverport + "/"
				+ defaultdb, prop);
	}

	/**
	 * Start data import
	 * 
	 * @param source
	 * @param prop
	 */
	public void importData(String source, Properties prop)throws Exception {
		DOMParser parser = new DOMParser();
		try {
			// Read the entire document into memory
			parser.setFeature( "http://apache.org/xml/features/dom/defer-node-expansion",false);
			parser.parse(new InputSource(new StringReader(source)));
		} catch (Exception e) {
			if (continueOnErrorGeneral)
				printError("Error importing XML:\n"+e.getMessage());
			else
				throw new Exception("Error importing XML:\n"+e.getMessage());
		}
		Document d = parser.getDocument();
		NodeList databases = d.getChildNodes();
		for (int i = 0; i < databases.getLength(); i++)
			if (databases.item(i).getNodeName().equals(DATABASENODE))
				processDatabase(databases.item(i));
			else
				throw new Exception("invalid database node \n");

		Iterator iT = sqlInstruction.iterator();
		while (iT.hasNext()) {
			String instr = (String) iT.next();

			try {
				stat.execute(instr);
				
			} catch (SQLException e) {
				if (continueOnErrorGeneral)
					printError("Error importation XML: \n"+e.getMessage());
				else
					throw new Exception("Error importation XML: \n"+e.getMessage());
			}

		}

		Iterator iD = sqlIntroduction.iterator();
		while (iD.hasNext()) {
			String intr = (String) iD.next();

			try {
			
				stat.executeUpdate(intr);

			} catch (SQLException e) {
				if (continueOnErrorGeneral)
					printError("Error importation XML:\n"+e.getMessage());
				else
					throw new Exception("Error importation XML:\n"+e.getMessage());
			}

		}

	}

	/**
	 * Process a database node
	 * 
	 * @param racine
	 */
	private void processDatabase(Node racine)throws Exception {
		printMessage("Processing database node");
		createDatabase(databaseName);
		NodeList children = racine.getChildNodes();
		for (int i = 0; i < children.getLength(); i++)
			if (children.item(i).getNodeName().equals(TABLESNODE))
				processTables(children.item(i)); // Tabelle
			else if (children.item(i).getNodeName().equals(DATABASEINFONODE))
				processDBInfo(children.item(i)); // Informazione
			else
				throw new Exception("invalid database node \n");

	}

	/**
	 * Process tables node
	 * 
	 * @param tablesNodes
	 */
	private void processTables(Node tablesNodes) throws Exception{
		printMessage("Processing tables node");
		NodeList children = tablesNodes.getChildNodes();
		for (int i = 0; i < children.getLength(); i++) {
			if (children.item(i).getNodeName().equals(STRUCTURENODE))
				processTablesName(children.item(i));
			else
				throw new Exception("invalid tables nodes \n");
		}
	}

	/**
	 * Process Database Infos node
	 * 
	 * @param dbInfos
	 */

	private void processDBInfo(Node dbInfos)throws Exception {
		printMessage("Processing dbInfos node");
		NodeList childrenDbInfos = dbInfos.getChildNodes();
		for (int r = 0; r < childrenDbInfos.getLength(); r++) {
			if (childrenDbInfos.item(r).getNodeName().equals(
					DATABASEINFODATATYPE))
				processDataType(childrenDbInfos.item(r));
			else
				throw new Exception("Invalid dbInfos node \n");
			

		}

	}

	/**
	 * Process Data type node
	 * 
	 * @param infosNodes
	 */

	private void processDataType(Node infosNodes) throws Exception{
		printMessage("Processing data type node");
		NodeList childrenDataType = infosNodes.getChildNodes();
		for (int r = 0; r < childrenDataType.getLength(); r++) {
			if (childrenDataType.item(r).getNodeName().equals(
					DATABASEINFOTYPECLASS))
				processTypeClass(childrenDataType.item(r));
			else
				throw new Exception("Invalid DataType node \n");
				

		}
	}

	/**
	 * Process Type Class node
	 * 
	 * @param infosNodes
	 */

	private void processTypeClass(Node infosNodes)throws Exception {
		printMessage("Processing typeClass node");
		NodeList childrenDataType = infosNodes.getChildNodes();
		for (int r = 0; r < childrenDataType.getLength(); r++) {
			if (childrenDataType.item(r).getNodeName().equals(
					DATABASEINFOTYPENAME))
				getInformationTypeName(childrenDataType.item(r));
			else
				throw new Exception("Invalid TypeClass node \n");
			

		}
	}

	/**
	 * Information type Name
	 * 
	 * @param infosNodes
	 */

	private void getInformationTypeName(Node infosNodes)throws Exception {
		printMessage("Processing information type name node");
		NodeList childrenTypeClass = infosNodes.getChildNodes();
		for (int d = 0; d < childrenTypeClass.getLength(); d++) {
			Node typeName = childrenTypeClass.item(d);
			NamedNodeMap mapTypeClass = typeName.getAttributes();
			for (int q = 0; d <= mapTypeClass.getLength(); q++) {
				String TypeAttName = mapTypeClass.item(d).getNodeName()
						+ mapTypeClass.item(d).getNodeValue();
			}
		}
	}

	/**
	 * Process table name
	 * 
	 * @param tableNamesNode
	 */

	private void processTablesName(Node tableNamesNode)throws Exception {
		printMessage("Process tablesName node");
		NamedNodeMap mapNames = tableNamesNode.getAttributes();
		String nameTable = "";
		for (int e = 0; e < mapNames.getLength(); e++) {
			nameTable = mapNames.item(e).getNodeValue();
		}
		NodeList children = tableNamesNode.getChildNodes();

		for (int i = 0; i < children.getLength(); i++)
			if (children.item(i).getNodeName().equals(INFORMATIONODE))
				processInformation(nameTable, children.item(i));

			else if (children.item(i).getNodeName().equals(ENTRIESNODE))
				processEntries(nameTable, children.item(i));
			else
				throw new Exception("Invalid tableNames node \n");
			
	}

	/**
	 * process Information, string for create table
	 * 
	 * @param nameTable
	 * @param informationNode
	 */

	private void processInformation(String nameTable, Node informationNode)throws Exception {
		printMessage("Processing information node");
		NodeList children = informationNode.getChildNodes();
		listeColumn.clear();
		for (int i = 0; i < children.getLength(); i++) {
			if (children.item(i).getNodeName().equals(COLUMNNODE)) {

				processColumnProperties(nameTable, children.item(i));

			} else
				throw new Exception("Invalid informationNode node \n");
				
		}
		printMessage("Processing create table"+nameTable);
		Iterator columninfo = listeColumn.iterator();
		String sqlquery = "create table " + unescapeHTML(nameTable, 0) + " ( ";
		while (columninfo.hasNext()) {
			sqlquery += unescapeHTML((String) columninfo.next(), 0);
			if (columninfo.hasNext())
				sqlquery += ",";
		}

		if (listPrimaryKeys.size() > 0)
			sqlquery += ", PRIMARY KEY(";

		Iterator primaryk = listPrimaryKeys.iterator();
		while (primaryk.hasNext()) {
			sqlquery += unescapeHTML((String) primaryk.next(), 0);
			if (primaryk.hasNext())
				sqlquery += ",";
			else
				sqlquery += "));";

		}

		sqlInstruction.add(sqlquery);

		listPrimaryKeys.clear();
	}

	/**
	 * process insert data in table
	 * 
	 * @param nameTable
	 * @param entriesNode
	 */

	private void processInsertTableString(String nameTable, Node entriesNode)throws Exception {
		printMessage("Processing insert string table");
		String insertStringTable = null;
		NodeList listData = entriesNode.getChildNodes();

		for (int u = 0; u < listData.getLength(); u++) {
			Node data = listData.item(u);
			NamedNodeMap mapData = data.getAttributes();

			for (int g = 0; g < mapData.getLength(); g++) {

				if (mapData.item(g).getNodeName().equals("value")) {
					String value = mapData.item(g).getNodeValue();

					valueData.add(value);
				}

			}
			printMessage("Processing  insert into string");
			insertStringTable = "insert into " + unescapeHTML(nameTable, 0)
					+ " values" + "(";
			Iterator valueIterator = valueData.iterator();
			while (valueIterator.hasNext()) {

				String vd = unescapeHTML((String) valueIterator.next(), 0);
				insertStringTable = insertStringTable + "\"" + vd + "\"";
				if (valueIterator.hasNext())
					insertStringTable = insertStringTable + ",";
				else
					insertStringTable = insertStringTable + ");";

			}

		}
		valueData.clear();

		sqlIntroduction.add(insertStringTable);

	}

	/**
	 * Process column properties
	 * 
	 * @param nameTable
	 * @param informationNode
	 */

	private void processColumnProperties(String nameTable, Node informationNode)throws Exception {
		printMessage("Processing column properties from tables");

		NamedNodeMap mapColumn = informationNode.getAttributes();
		for (int s = 0; s < mapColumn.getLength(); s++) {
			String ColAtt = mapColumn.item(s).getNodeValue();
			String ColAttName = "Column Attr.Table="
					+ mapColumn.item(s).getNodeName()
					+ mapColumn.item(s).getNodeValue();
		}

		ColType = mapColumn.getNamedItem("type").getNodeValue();
		System.out.println("ColType=" + ColType);
		ColSize = mapColumn.getNamedItem("size").getNodeValue();
		System.out.println("ColSize=" + ColSize);
		ColIsNullable = mapColumn.getNamedItem("isNullable").getNodeValue();
		ColIsAutoIncremental = mapColumn.getNamedItem("isAutoIncrement")
				.getNodeValue();
		nomeColonne = mapColumn.getNamedItem("name").getNodeValue();
		if (mapColumn.getNamedItem("primaryKey") == null)
			primaryKey = "";
		else
			primaryKey = mapColumn.getNamedItem("primaryKey").getNodeValue();

		String InitCreateTabelle;
		String InitInsertDate;
		use = "use " + NomeDatabase;
		String autoinc;
		if (ColIsAutoIncremental.equals("false"))
			autoinc = "";
		else
			autoinc = "AUTO_INCREMENT";

		String isnull;
		if (ColIsNullable.equals("0"))
			isnull = " NOT NULL ";
		else
			isnull = " NULL ";

		listeColumn.add(nomeColonne + " " + ColType + "(" + ColSize + ")"
				+ "  " + autoinc + isnull);
		
		if (primaryKey.equals("true")) {
			listPrimaryKeys.add(nomeColonne);
		
		}

	}

	/**
	 * Process entries node
	 * 
	 * @param nameTable
	 * @param entriesNode
	 */

	private void processEntries(String nameTable, Node entriesNode)throws Exception {
		printMessage("Processing entries node");
		NodeList children = entriesNode.getChildNodes();

		for (int i = 0; i < children.getLength(); i++)
			if (children.item(i).getNodeName().equals(ENTRYNODE)) {

				processInsertTableString(nameTable, children.item(i));
			} else
				printMessage("Invalid entriesNode \n");
	}

	/**
	 * Process data node
	 * 
	 * @param datesNode
	 */

	private void processDates(Node datesNode) throws Exception{
		printMessage("Processing data node");
		NodeList children = datesNode.getChildNodes();
		for (int i = 0; i < children.getLength(); i++)
			if (children.item(i).getNodeName().equals("date"))
				processDates(children.item(i));
			else
				throw new Exception("Invalid entriesNode \n");
				
	}

	/**
	 * Process Primary key node 
	 * 
	 * @param primaryKeysNode
	 */

	private void processPrimaryKeys(Node primaryKeysNode)throws Exception {
		printMessage("Processing primary key");

		String PrimaryAtt = "";
		NamedNodeMap mapPrimary = primaryKeysNode.getAttributes();
		for (int k = 0; k < mapPrimary.getLength(); k++) {
			PrimaryAtt = mapPrimary.item(k).getNodeValue();
			primaryKeys.add(PrimaryAtt);
		}

	}

	/**
	 * Information old
	 * 
	 * @param tables
	 */
	private void getTableCount(Node tables) throws Exception{
		NodeList children = tables.getChildNodes();
		numberTables = children.getLength();
	}

	/**
	 * 
	 * creation databases
	 * 
	 * @param databaseName
	 */

	private void createDatabase(String databaseName)throws Exception {
		printMessage("Processing create database:"+ databaseName);
		String sqlString = "create database " + databaseName;
		try {
			boolean result = stat.execute(sqlString);
		} catch (SQLException e) {
			if (continueOnErrorGeneral)
				printError("Error creation databases: \n"+e.getLocalizedMessage());
			else
				throw new Exception("Error creation databases: \n"+e.getLocalizedMessage());
		}

		String databaseUse = "use " + databaseName;
		try {
			stat.execute(databaseUse);
		} catch (SQLException e1) {
			if (continueOnErrorGeneral)
				printError("Error use databases: \n"+e1.getMessage());
			else
				throw new Exception("Error use databases: \n"+e1.getMessage());
		}
	}
	public void setContinueOnErrorGeneral() {
		this.continueOnErrorGeneral = true;
	}

	public static final String unescapeHTML(String s, int f)throws Exception {
		String[][] escape = { { "&lt;", "<" }, { "&gt;", ">" },
				{ "&amp;", "&" }, { "&quot;", "\"" }, { "&agrave;", "à" },
				{ "&Agrave;", "À" }, { "&acirc;", "â" }, { "&auml;", "ä" },
				{ "&Auml;", "Ä" }, { "&Acirc;", "Â" }, { "&aring;", "å" },
				{ "&Aring;", "Å" }, { "&aelig;", "æ" }, { "&AElig;", "Æ" },
				{ "&ccedil;", "ç" }, { "&Ccedil;", "Ç" }, { "&eacute;", "é" },
				{ "&Eacute;", "É" }, { "&egrave;", "è" }, { "&Egrave;", "È" },
				{ "&ecirc;", "ê" }, { "&Ecirc;", "Ê" }, { "&euml;", "ë" },
				{ "&Euml;", "Ë" }, { "&iuml;", "ï" }, { "&Iuml;", "Ï" },
				{ "&ocirc;", "ô" }, { "&Ocirc;", "Ô" }, { "&ouml;", "ö" },
				{ "&Ouml;", "Ö" }, { "&oslash;", "ø" }, { "&Oslash;", "Ø" },
				{ "&szlig;", "ß" }, { "&ugrave;", "ù" }, { "&Ugrave;", "Ù" },
				{ "&ucirc;", "û" }, { "&Ucirc;", "Û" }, { "&uuml;", "ü" },
				{ "&Uuml;", "Ü" }, { "&nbsp;", " " }, { "&reg;", "\u00a9" },
				{ "&copy;", "\u00ae" }, { "&euro;", "\u20a0" } };
		int i, j, k, l;

		i = s.indexOf("&", f);
		if (i > -1) {
			j = s.indexOf(";", i);
			/** 
			we don't start from the beginning
			the next time, to handle the case of
			the &amp;
			thanks to Pieter Hertogh for the bug fix!
			*/
			f = i + 1;
			// --------
			if (j > i) {
				/** ok this is not most optimized way to
				// do it, a StringBuffer would be better,
				// this is left as an exercise to the reader!
				*/
				String temp = s.substring(i, j + 1);
				/* search in escape[][] if temp is there*/
				k = 0;
				while (k < escape.length) {
					if (escape[k][0].equals(temp))
						break;
					else
						k++;
				}
				if (k < escape.length) {
					s = s.substring(0, i) + escape[k][1] + s.substring(j + 1);
					return unescapeHTML(s, f); /* recursive call*/
				}
			}
		}
		return s;
	}




	/* (non-Javadoc)
	 * @see support.ExportInterface#exportData()
	 */
	public void exportData() throws Exception {
		importData(source,prop);
	}
	
	public void forceCloseConnection() {
		try {
			conn.close();
			printMessage("Done closing connection");
		} catch (Exception e) {
			try {
				printError("Error closing connection to database");
			} catch (Exception e1) {
			}
		}
	}

	/* (non-Javadoc)
	 * @see support.ExportInterface#setLogText(org.eclipse.swt.widgets.Text)
	 */
	public void setLogText(Text log) {
		this.log = log;	
	}


	/* (non-Javadoc)
	 * @see support.ExportInterface#selectDatabase(java.lang.String)
	 */
	public void selectDatabase(String database) throws Exception {
		this.databaseName = database;
	}
	
	public void setSource(String source) {
		this.source = source;
	}

}
