/**
Master Project WS-2004 ~ SS-2005, Computer Science

University of Fribourg, Information Systems Research Group (http://diuf.unifr.ch/is)

Student :    Amos Brocco <amos.brocco@unifr.ch>
Supervisors: Prof. Dr. Andreas Meier <andreas.meier@unifr.ch>
             Nicolas Werro <nicolas.werro@unifr.ch>
        __  __
 _ _ ___\ \/ /__ _ _ _  _ _  ___
| '_/ _ \>  </ _` | ' \| ' \/ -_)
|_| \___/_/\_\__,_|_||_|_||_\___|

roXanne, Secure XML Data Storage Framework
x.core & x.click Copyright (C) 2004-2005 Amos Brocco <amos.brocco@unifr.ch>
x.mill Copyright (C) 2004-2005 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

This product includes software developed by the JDOM Project (http://www.jdom.org/).
The Jaxup library is Copyright (c) 2001 - 2003 Erwin Bolwidt, used and modified under the BSD License.
Encryption modules used are Copyright (c) 2000 - 2004 The Legion Of The Bouncy Castle (http://www.bouncycastle.org).
JAXEN  is Copyright 2003 (C) The Werken Company. All Rights Reserved.
Base64 was released as Public Domain by its author Robert Harder (rob@iharder.net)
MySQL JDBC Connector is (c) 1995-2005 MySQL AB. All rights reserved. Released under the GNU/GPL License.
PostgreSQL JDBC Driver is Copyright (c) 2004-2005 The PostgreSQL Global Development Group, distributed under the BSD license
JArgs was created Steve Purcell, now mantained by Ewan Mellorby and released under the BSD licence.
**/

/*
 * Wizard to upload a new key
 */
package wizards.addkey;

import org.eclipse.jface.wizard.Wizard;

import application.Context;

/**
 * XUpdate wizard
 * 
 * @author mriya3
 *  
 */
public class AddKeyWizard extends Wizard {

	public SelectKeyPage selectkey_page;

	public ExecuteAddKeyPage executeaddkey_page;

	private Context _context;

	public String method;

	public String id;

	public String filename;

	private String type;

	private boolean finished;

	/**
	 * Constructs the wizard
	 */
	public AddKeyWizard(Context c) {
		super();
		this._context = c;
		setWindowTitle("Add key to session");
		setNeedsProgressMonitor(true);
	}

	/**
	 * Add wizard pages
	 */
	public void addPages() {
		selectkey_page = new SelectKeyPage(_context);
		executeaddkey_page = new ExecuteAddKeyPage(_context);
		addPage(selectkey_page);
		addPage(executeaddkey_page);
	}

	/**
	 * Finishes up wizard
	 */
	public boolean performFinish() {
		/* Nothing to do here */
		return true;
	}

	/**
	 * True if we can finish
	 */
	public boolean canFinish() {
		return finished;
	}

	/**
	 * @param text
	 */
	public void setAlgorithmName(String text) {
		this.method = text;

	}

	/**
	 * @param text
	 */
	public void setKeyId(String text) {
		this.id = text;

	}

	/**
	 * @param text
	 */
	public void setKeyFilename(String text) {
		this.filename = text;

	}

	/**
	 * @return
	 */
	public String getKeyFilename() {
		return this.filename;
	}

	/**
	 * @return
	 */
	public String getKeyId() {
		return this.id;
	}

	/**
	 * @return
	 */
	public String getAlgorithmName() {
		return this.method;
	}

	public void setKeyType(String type) {
		this.type = type;
	}

	public String getKeyType() {
		return this.type;
	}

	public void isFinished() {
		this.finished = true;
	}

}
