/**
Master Project WS-2004 ~ SS 2005, Computer Science

University of Fribourg, Information Systems Research Group (http://diuf.unifr.ch/is)

Student :    Amos Brocco <amos.brocco@unifr.ch>
Supervisors: Prof. Dr. Andreas Meier <andreas.meier@unifr.ch>
             Nicolas Werro <nicolas.werro@unifr.ch>
        __  __
 _ _ ___\ \/ /__ _ _ _  _ _  ___
| '_/ _ \>  </ _` | ' \| ' \/ -_)
|_| \___/_/\_\__,_|_||_|_||_\___|

roXanne, Secure XML Data Storage Framework
x.core & x.click Copyright (C) 2004-2005 Amos Brocco <amos.brocco@unifr.ch>
x.mill Copyright (C) 2004-2005 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

This product includes software developed by the JDOM Project (http://www.jdom.org/).
The Jaxup library is Copyright (c) 2001 - 2003 Erwin Bolwidt, used and modified under the BSD License.
Encryption modules used are Copyright (c) 2000 - 2004 The Legion Of The Bouncy Castle (http://www.bouncycastle.org).
JAXEN  is Copyright 2003 (C) The Werken Company. All Rights Reserved.
Base64 was released as Public Domain by its author Robert Harder (rob@iharder.net)
MySQL JDBC Connector is (c) 1995-2005 MySQL AB. All rights reserved. Released under the GNU/GPL License.
PostgreSQL JDBC Driver is Copyright (c) 2004-2005 The PostgreSQL Global Development Group, distributed under the BSD license
JArgs was created Steve Purcell, now mantained by Ewan Mellorby and released under the BSD licence.
**/

/*
 * Adds a new key
 */
package wizards.addkey;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

import keymanager.Key;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;

import application.Context;
import application.Executor;
import application.ExecutorCallbacksListener;

/**
 * @author mriya3
 *  
 */
public class ExecuteAddKeyPage extends WizardPage {

	private Context context;

	private Text logText;

	private Button saveLogButton;

	private String filename;

	private String method;

	private String id;

	private String type;

	String keydata = null;

	class AddKeyResultListener implements ExecutorCallbacksListener {

		public void dataAvailable(Executor ex, final String request,
				BufferedReader response) {
			Document doc = null;
			try {
				/* Parse result */
				doc = (new SAXBuilder()).build(response);
			} catch (final JDOMException e) {
				/* Sync start */context.getDisplay().syncExec(new Runnable() {
					public void run() {
						logText.append("Error while uploading key");
						e.printStackTrace();
						/* Sync end */}
				});
				return;
			} catch (final IOException e) {
				/* Sync start */context.getDisplay().syncExec(new Runnable() {
					public void run() {
						logText.append("Cannot connect to server");
						e.printStackTrace();
						/* Sync end */}
				});
				return;
			}

			/* Parse tree */
			Element rootNode = doc.getRootElement();
			Element keychain = rootNode.getChild("keychain");
			Element addkey = keychain.getChild("addkey");
			String encstatus = addkey.getAttributeValue("encryption");
			String decstatus = addkey.getAttributeValue("decryption");

			if ((encstatus == null || encstatus.equals("added"))
					&& (decstatus == null || decstatus.equals("added")))
				/* Sync start */context.getDisplay().syncExec(new Runnable() {
					public void run() {
						logText.append("Done!\n");
						if (type.equals("encryption")
								|| type.equals("decryption")) {
							Key k = new Key();
							k.id = id;
							k.source = filename;
							k.method = method;
							k.type = type;
							k.keydata = keydata;
							context.addKey(k);
							logText.append("Key for " + type + " with "
									+ method + "/" + id + " loaded");
						} else {
							Key ke = new Key();
							ke.id = id;
							ke.source = filename;
							ke.method = method;
							ke.type = "encryption";
							ke.keydata = keydata;
							context.addKey(ke);
							Key kd = new Key();
							kd.id = id;
							kd.source = filename;
							kd.method = method;
							kd.type = "decryption";
							kd.keydata = keydata;
							context.addKey(kd);
							logText
									.append("Keys for encryption/decryption with "
											+ method + "/" + id + " loaded");
						}
						setPageComplete(true);
						((AddKeyWizard) getWizard()).isFinished();
						getWizard().getContainer().updateButtons();
						/* Sync end */}
				});
			else
				/* Sync start */context.getDisplay().syncExec(new Runnable() {
					public void run() {
						logText.append("Error!");
						setPageComplete(false);
						/* Sync end */}
				});

		}
	}

	protected ExecuteAddKeyPage(Context context) {
		super("ExecuteXUpdatePage");
		setTitle("Add key to session");
		setDescription("Uploading key. See log for information");
		this.context = context;
	}

	/**
	 * Creates this page
	 */
	public void createControl(Composite composite) {
		Composite container = new Composite(composite, SWT.NULL);
		GridLayout layout = new GridLayout();
		container.setLayout(layout);
		layout.numColumns = 1;
		layout.verticalSpacing = 5;

		Label logLabel = new Label(container, SWT.NULL);
		logLabel.setText("Operation log: ");

		logText = new Text(container, SWT.BORDER | SWT.MULTI | SWT.V_SCROLL);
		GridData gd2 = new GridData(GridData.FILL_BOTH);
		logText.setLayoutData(gd2);

		saveLogButton = new Button(container, SWT.NULL | SWT.RIGHT);
		saveLogButton.setText("Save log...");
		saveLogButton.setEnabled(true);
		saveLogButton.addSelectionListener(new SelectionListener() {
			public void widgetSelected(SelectionEvent e) {
				DataOutputStream out = null;
				try {
					FileDialog fd = new FileDialog(getShell(), SWT.SAVE);
					fd.setText("Save log to file");
					fd.setFilterPath(System.getProperty("os.path"));
					String[] filterExt = { "*.txt", "*.*" };
					fd.setFilterExtensions(filterExt);
					String selected = fd.open();
					File file = new File(selected);
					out = new DataOutputStream(new FileOutputStream(file));
					out.writeBytes(logText.getText());
					out.close();
					logText.append("\nLog saved to file: " + selected);
				} catch (Exception e1) {
					logText.append("\nCannot save log to file!");
					try {
						if (out != null)
							out.close();
					} catch (IOException e2) {
						e2.printStackTrace();
					}
				}
			}

			public void widgetDefaultSelected(SelectionEvent e) {
			}
		});


		setPageComplete(false);
		setControl(container);
	}

	/**
	 * Performs some actions when accessing this page
	 *  
	 */
	void onEnterPage() {
		AddKeyWizard wizard = (AddKeyWizard) getWizard();
		filename = wizard.getKeyFilename();
		id = wizard.getKeyId();
		type = wizard.getKeyType();
		method = wizard.getAlgorithmName();
		executeAddKey();
	}

	/**
	 * Launch XUpdate execution
	 */
	private void executeAddKey() {
		DataInputStream in = null;
		File file = new File(filename);
		if (!file.exists())
			return;
		try {
			in = new DataInputStream(new FileInputStream(file));
			keydata = in.readUTF();
			in.close();
		} catch (Exception e) {
			logText.append("Error while reading key file.\n");
			try {
				if (in != null)
					in.close();
			} catch (IOException e2) {
				e2.printStackTrace();
			}
			return;
		}

		if (method.equals("<Autodetect>")) {
			logText.append("Trying to autodetect key format...");
			ByteArrayInputStream indata = new ByteArrayInputStream(
					support.Base64.decode(keydata));

			SAXBuilder sb = new SAXBuilder();
			Document doc = null;
			try {
				doc = sb.build(indata);
			} catch (Exception e) {
				logText.append("error!\nFailed to autodetect key format\n");
				return;
			}
			Element root = doc.getRootElement();
			/* Check root node name */
			if ((root.getName().equals("RoXanneAES128Key"))) {
				method = "AES_128";
				logText.append("success!\nKey format is " + method + "\n");
			} else if ((root.getName().equals("RoXanneDESedeKey"))) {
				method = "DESede";
				logText.append("success!\nKey format is " + method + "\n");
			} else if ((root.getName().equals("RoXanneRSAPublicKey"))) {
				method = "RSA_V1_5";
				logText.append("success!\nKey format is " + method + "(Public)\n");
				if(type.equals("decryption")) {
					logText.append("Error! Public key is not a valid decryption key");
					return;
				}
			} else if ((root.getName().equals("RoXanneRSAPrivateKey"))) {
				method = "RSA_V1_5";
				logText.append("success!\nKey format is " + method + "(Private)\n");
				if(type.equals("encryption")) {
					logText.append("Error! Private key is not a valid encryption key");
					return;
				}
			} else {
				logText.append("error!\nFailed to autodetect key format\n");
				return;

			}
		}

		String query = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><roxannequery login=\""
				+ context.getSession().getLogin()
				+ "\" password=\""
				+ context.getSession().getPassword()
				+ "\" sessionId=\""
				+ context.getSession().getSessionId()
				+ "\" persistent=\"true\"><keychain><addkey id=\""
				+ id
				+ "\" method=\"" + method + "\">";
		if (type.equals("encryption") || type.equals("decryption"))
			query = query + "<" + type + ">" + keydata + "</" + type
					+ "></addkey></keychain></roxannequery>";
		else {
			if(method.equals("RSA_V1_5")) {
				logText.append("Error! Cannot add asymmetric key data for both!");
				return;
			}
			query = query + "<encryption>" + keydata
					+ "</encryption><decryption>" + keydata
					+ "</decryption></addkey></keychain></roxannequery>";
			}

		Executor ex = new Executor(new AddKeyResultListener(), context
				.getSession());
		ex.setQuery(query);
		ex.start();
	}

	/**
	 * Returns if we can go to next page (finish)
	 */
	public boolean canFlipToNextPage() {
		return false;
	}

}
