/**
Master Project WS-2004 ~ SS 2005, Computer Science

University of Fribourg, Information Systems Research Group (http://diuf.unifr.ch/is)

Student :    Amos Brocco <amos.brocco@unifr.ch>
Supervisors: Prof. Dr. Andreas Meier <andreas.meier@unifr.ch>
             Nicolas Werro <nicolas.werro@unifr.ch>
        __  __
 _ _ ___\ \/ /__ _ _ _  _ _  ___
| '_/ _ \>  </ _` | ' \| ' \/ -_)
|_| \___/_/\_\__,_|_||_|_||_\___|

roXanne, Secure XML Data Storage Framework
x.core & x.click Copyright (C) 2004-2005 Amos Brocco <amos.brocco@unifr.ch>
x.mill Copyright (C) 2004-2005 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

This product includes software developed by the JDOM Project (http://www.jdom.org/).
The Jaxup library is Copyright (c) 2001 - 2003 Erwin Bolwidt, used and modified under the BSD License.
Encryption modules used are Copyright (c) 2000 - 2004 The Legion Of The Bouncy Castle (http://www.bouncycastle.org).
JAXEN  is Copyright 2003 (C) The Werken Company. All Rights Reserved.
Base64 was released as Public Domain by its author Robert Harder (rob@iharder.net)
MySQL JDBC Connector is (c) 1995-2005 MySQL AB. All rights reserved. Released under the GNU/GPL License.
PostgreSQL JDBC Driver is Copyright (c) 2004-2005 The PostgreSQL Global Development Group, distributed under the BSD license
JArgs was created Steve Purcell, now mantained by Ewan Mellorby and released under the BSD licence.
**/

/*
 * Collects data to perform XUpdate
 */
package wizards.addkey;

import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import application.Context;

/**
 * @author mriya3
 *  
 */
public class SelectKeyPage extends WizardPage {

	Context context;

	/* Fields */
	Text id;

	Text filename;

	Button selectKeyFileButton;

	Combo algorithmName;

	Button enc;

	Button dec;

	Button both;

	String keytype;

	String[] methods = { "<Autodetect>", "AES_128", "DESede", "RSA_V1_5" };

	private boolean canContinue;

	protected SelectKeyPage(Context context) {
		super("SelectKeyPage");
		setTitle("Select Key");
		setDescription("Please enter key parameters");
		this.context = context;
	}

	public void createControl(Composite parent) {
		Composite container = new Composite(parent, SWT.NULL);
		GridLayout layout = new GridLayout();
		container.setLayout(layout);
		layout.numColumns = 2;
		layout.verticalSpacing = 5;

		GridData gd = new GridData(GridData.FILL_HORIZONTAL);

		/* Method selection */
		Label modificationLabel = new Label(container, SWT.NULL);
		modificationLabel.setText("&Method:");

		algorithmName = new Combo(container, SWT.READ_ONLY);
		algorithmName.setItems(methods);

		algorithmName.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				validate();
			}
		});
		algorithmName.setLayoutData(gd);

		Label modeLabel = new Label(container, SWT.NULL);
		modeLabel.setText("&Key type:");
		Composite composite = new Composite(container, SWT.NULL);
		composite.setLayout(new RowLayout());
		enc = new Button(composite, SWT.RADIO);
		enc.setText("Encryption");
		enc.addSelectionListener(new SelectionListener() {
			public void widgetSelected(SelectionEvent e) {
				keytype = "encryption";
				validate();
			}

			public void widgetDefaultSelected(SelectionEvent e) {
			}
		});
		dec = new Button(composite, SWT.RADIO);
		dec.setText("Decryption");
		dec.addSelectionListener(new SelectionListener() {
			public void widgetSelected(SelectionEvent e) {
				keytype = "decryption";
				validate();
			}

			public void widgetDefaultSelected(SelectionEvent e) {
			}
		});

		both = new Button(composite, SWT.RADIO);
		both.setText("Both");
		both.addSelectionListener(new SelectionListener() {
			public void widgetSelected(SelectionEvent e) {
				keytype = "both";
				validate();
			}

			public void widgetDefaultSelected(SelectionEvent e) {
			}
		});

		Label idLabel = new Label(container, SWT.NULL);
		idLabel.setText("Key identifier:");

		id = new Text(container, SWT.BORDER | SWT.SINGLE);
		id.setText("");
		id.setLayoutData(gd);
		id.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				validate();
			}
		});

		Label keyLabel = new Label(container, SWT.NULL);
		keyLabel.setText("Enter key file path:");

		filename = new Text(container, SWT.BORDER | SWT.SINGLE);
		filename.setText("");
		filename.setLayoutData(gd);
		filename.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				validate();
			}
		});

		Label orLabel = new Label(container, SWT.NULL);
		orLabel.setText("Or...");
		selectKeyFileButton = new Button(container, SWT.NULL);
		selectKeyFileButton.setText("Browse for a key file on disk");
		selectKeyFileButton.setLayoutData(gd);
		selectKeyFileButton.addSelectionListener(new SelectionListener() {
			public void widgetSelected(SelectionEvent e) {
				try {
					FileDialog fd = new FileDialog(getShell(), SWT.OPEN);
					fd.setText("Select key file");
					fd.setFilterPath(System.getProperty("os.path"));
					String[] filterExt = { "*.rsk", "*.*" };
					fd.setFilterExtensions(filterExt);
					String selected = fd.open();
					filename.setText(selected);
				} catch (Exception e1) {
				}
			}

			public void widgetDefaultSelected(SelectionEvent e) {
			}
		});

		canContinue = false;
		setPageComplete(false);
		setControl(container);
	}

	void onEnterPage() {
		validate();
		getWizard().getContainer().updateButtons();
	}

	private void validate() {

		if (algorithmName.getText().trim().length() == 0) {
			updateStatus("An encryption method must be specified");
			return;
		}
		
		if (algorithmName.getText().equals("RSA_V1_5")) {
			both.setEnabled(false);
		} else {
			both.setEnabled(true);
		}

		if (keytype == null) {
			updateStatus("Key type must be specified");
			return;
		}

		if (id.getText().equals("")) {
			updateStatus("A key identifier must be specified");
			return;
		}

		if (filename.getText().trim().length() == 0) {
			updateStatus("A key data file must be specified");
			return;
		}

		if (!(enc.isEnabled()) && !(dec.isEnabled())) {
			updateStatus("Please select key type");
			return;
		}

		saveData();
		canContinue = true;
		getWizard().getContainer().updateButtons();
		updateStatus(null);

	}

	private void updateStatus(String message) {
		setErrorMessage(message);
		if(message==null)
			canContinue = false;
	}

	public boolean canFlipToNextPage() {
		return canContinue;
	}

	/**
	 * Saves values entered
	 *  
	 */
	public void saveData() {
		AddKeyWizard wizard = (AddKeyWizard) getWizard();
		wizard.setAlgorithmName(algorithmName.getText());
		wizard.setKeyId(id.getText());
		wizard.setKeyFilename(filename.getText());
		wizard.setKeyType(keytype);
	}

	public IWizardPage getNextPage() {
		saveData();
		ExecuteAddKeyPage page = ((AddKeyWizard) getWizard()).executeaddkey_page;
		page.onEnterPage();
		return page;
	}

}
