/**
Master Project WS-2004 ~ SS-2005, Computer Science

University of Fribourg, Information Systems Research Group (http://diuf.unifr.ch/is)

Students :   Amos Brocco <amos.brocco@unifr.ch>
			 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>
Supervisors: Prof. Dr. Andreas Meier <andreas.meier@unifr.ch>
             Nicolas Werro <nicolas.werro@unifr.ch>
        __  __
 _ _ ___\ \/ /__ _ _ _  _ _  ___
| '_/ _ \>  </ _` | ' \| ' \/ -_)
|_| \___/_/\_\__,_|_||_|_||_\___|

roXanne, Secure XML Data Storage Framework
x.core & x.click Copyright (C) 2004-2005 Amos Brocco <amos.brocco@unifr.ch>
x.mill Copyright (C) 2004-2005 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

This product includes software developed by the JDOM Project (http://www.jdom.org/).
The Jaxup library is Copyright (c) 2001 - 2003 Erwin Bolwidt, used and modified under the BSD License.
Encryption modules used are Copyright (c) 2000 - 2004 The Legion Of The Bouncy Castle (http://www.bouncycastle.org).
JAXEN  is Copyright 2003 (C) The Werken Company. All Rights Reserved.
Base64 was released as Public Domain by its author Robert Harder (rob@iharder.net)
MySQL JDBC Connector is (c) 1995-2005 MySQL AB. All rights reserved. Released under the GNU/GPL License.
PostgreSQL JDBC Driver is Copyright (c) 2004-2005 The PostgreSQL Global Development Group, distributed under the BSD license
JArgs was created Steve Purcell, now mantained by Ewan Mellorby and released under the BSD licence.
**/

package wizards.exporttodb;

import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import application.Context;

public class XmillPage0 extends WizardPage {

	Combo providerCombo;
	
	Text server;
	Text port;
	Text username;
	Text password;
	
	private boolean canContinue;

	Text source;

	private Context context;

	private Button tryErrorGeneral;

	public XmillPage0(Context context) {
		super("xmill");
		setTitle("Xmill ");
		this.context = context;
		setDescription("Set connection parameters");
	}

	public void createControl(Composite parent) {
		Composite container = new Composite(parent, SWT.NULL);
		GridLayout layout = new GridLayout();
		container.setLayout(layout);
		layout.numColumns = 2;
		layout.verticalSpacing = 9;

		Label providerlabel = new Label(container, SWT.NULL);
		providerlabel.setText("&Provider:");

		GridData gd = new GridData(GridData.FILL_HORIZONTAL);

		providerCombo = new Combo(container, SWT.DROP_DOWN | SWT.READ_ONLY);
		providerCombo.setItems(new String[] { "MySQL", "PostgreSQL" });
		providerCombo.setLayoutData(gd);
		providerCombo.addSelectionListener(new SelectionListener() {
			public void widgetSelected(SelectionEvent e) {
				if(providerCombo.getText().equals("MySQL"))
					port.setText("3306");
				else if (providerCombo.getText().equals("PostgreSQL"))
					port.setText("5432");
				validate();
			}

			public void widgetDefaultSelected(SelectionEvent e) {}
		});
		
		providerCombo.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				if(providerCombo.getText().equals("MySQL"))
					port.setText("3306");
				else if (providerCombo.getText().equals("PostgreSQL"))
					port.setText("5432");
				validate();
			}
		});

		createLine(container, layout.numColumns);

		Label serverLabel = new Label(container, SWT.NULL);
		serverLabel.setText("&Server:");

		server = new Text(container, SWT.BORDER | SWT.SINGLE);
		gd = new GridData(GridData.FILL_HORIZONTAL);
		server.setLayoutData(gd);
		server.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				validate();
			}
		});

		Label portLabel = new Label(container, SWT.NULL);
		portLabel.setText("&Port:");

		port = new Text(container, SWT.BORDER | SWT.SINGLE);
		port.setLayoutData(gd);
		
		port.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				validate();
			}
		});

		createLine(container, layout.numColumns);

		Label usernameLabel = new Label(container, SWT.NULL);
		usernameLabel.setText("&User:");
		
		username = new Text(container, SWT.BORDER | SWT.SINGLE);
		username.setLayoutData(gd);
		
		username.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				validate();
			}
		});

		Label pwdLabel = new Label(container, SWT.NULL);
		pwdLabel.setText("&Password:");

		password = new Text(container, SWT.BORDER | SWT.SINGLE);
		password.setLayoutData(gd);
		password.setEchoChar('*');
		
		password.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				validate();
			}
		});

		createLine(container, layout.numColumns);
		
		Label sourceLabel = new Label(container, SWT.NULL);
		sourceLabel.setText("&Source:");

		source = new Text(container, SWT.BORDER | SWT.SINGLE);
		source.setLayoutData(gd);
		
		source.setText(context.getContextPath());

		
		source.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				validate();
			}
		});
		
		createLine(container, layout.numColumns);
		
		tryErrorGeneral = new Button( container, SWT.CHECK );
		tryErrorGeneral.setText( "Force continue on error" );
		tryErrorGeneral.setSelection(false);

		setControl(container);
		validate();
	}

	private void createLine(Composite parent, int ncol) {
		Label line = new Label(parent, SWT.SEPARATOR | SWT.HORIZONTAL
				| SWT.BOLD);
		GridData gridData = new GridData(GridData.FILL_HORIZONTAL);
		gridData.horizontalSpan = ncol;
		line.setLayoutData(gridData);
	}
	
	
	void onEnterPage() {
		canContinue = false;
		getWizard().getContainer().updateButtons();
		validate();
			
	}

	public boolean canFlipToNextPage() {
		return canContinue;
	}
	

	private void validate() {
		if(providerCombo.getText().trim().length()==0) {
			updateStatus("Please select provider");
			return;
		}
		
		if(port.getText().trim().length()==0) {
			updateStatus("Please check server port");
			return;
		}
		
		if(server.getText().trim().length()==0) {
			updateStatus("Please insert server address");
			return;
		}
		
		if(source.getText().trim().length()==0) {
			updateStatus("Please insert source XPath location");
			return;
		}
				
		saveData();
		canContinue = true;
		getWizard().getContainer().updateButtons();
		updateStatus(null);
	}

	private void updateStatus(String message) {
		setErrorMessage(message);
		if(message==null)
			canContinue = false;
	}
	
	public void saveData() {
		XmillWizard wizard = (XmillWizard) getWizard();
		wizard.setProvider(providerCombo.getText());
		wizard.setServer(server.getText());
		wizard.setServerPort(port.getText());
		wizard.setUsername(username.getText());
		wizard.setPassword(password.getText());
		wizard.setSource(source.getText());
		wizard.setTryOnErrorGeneral(tryErrorGeneral.getSelection());
	}

	public IWizardPage getNextPage() {
		saveData();
		XmillPage1 page = (XmillPage1) ((XmillWizard) getWizard()).page1;
		page.onEnterPage();
		return page;
	}
	
}
