/**
Master Project WS-2004 ~ SS-2005, Computer Science

University of Fribourg, Information Systems Research Group (http://diuf.unifr.ch/is)

Students :   Amos Brocco <amos.brocco@unifr.ch>
			 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>
Supervisors: Prof. Dr. Andreas Meier <andreas.meier@unifr.ch>
             Nicolas Werro <nicolas.werro@unifr.ch>
        __  __
 _ _ ___\ \/ /__ _ _ _  _ _  ___
| '_/ _ \>  </ _` | ' \| ' \/ -_)
|_| \___/_/\_\__,_|_||_|_||_\___|

roXanne, Secure XML Data Storage Framework
x.core & x.click Copyright (C) 2004-2005 Amos Brocco <amos.brocco@unifr.ch>
x.mill Copyright (C) 2004-2005 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

This product includes software developed by the JDOM Project (http://www.jdom.org/).
The Jaxup library is Copyright (c) 2001 - 2003 Erwin Bolwidt, used and modified under the BSD License.
Encryption modules used are Copyright (c) 2000 - 2004 The Legion Of The Bouncy Castle (http://www.bouncycastle.org).
JAXEN  is Copyright 2003 (C) The Werken Company. All Rights Reserved.
Base64 was released as Public Domain by its author Robert Harder (rob@iharder.net)
MySQL JDBC Connector is (c) 1995-2005 MySQL AB. All rights reserved. Released under the GNU/GPL License.
PostgreSQL JDBC Driver is Copyright (c) 2004-2005 The PostgreSQL Global Development Group, distributed under the BSD license
JArgs was created Steve Purcell, now mantained by Ewan Mellorby and released under the BSD licence.
**/

package wizards.exporttodb;

import org.eclipse.jface.wizard.Wizard;
import org.eclipse.swt.widgets.Text;

import support.ExportInterface;
import support.XMLMySQLImporter;
import support.XMLPostgreSQLImport;
import application.Context;
import application.UserInterface;

public class XmillWizard extends Wizard {
	public XmillPage0 page0;

	public XmillPage1 page1;

	public XmillPage2 page2;

	private boolean finished;

	private String provider;

	private String server;

	private String port;

	private String user;

	private String password;

	private String db;
	
	ExportInterface exporter;

	private UserInterface ui;

	private String source;

	private boolean tryContinueOnErrorGeneral;

	public XmillWizard(UserInterface ui) {
		super();
		this.ui = ui;
		setNeedsProgressMonitor(true);

	}

	public void addPages() {
		page0 = new XmillPage0(ui.getContext());
		page1 = new XmillPage1();
		page2 = new XmillPage2();
		addPage(page0);
		addPage(page1);
		addPage(page2);
	}

	public boolean performFinish() {
		return true;
	}
	
	public boolean canFinish() {
		return finished;
	}
	
	public void isFinished() {
		finished = true;
	}
	
	/**
	 * METHODS TO STORE AND RETRIEVE DATA BETWEEN PAGES
	 */
	
	public void setProvider(String provider) {
		this.provider = provider;
	}
	
	public String getProvider() {
		return provider;
	}
	
	public void setServer(String server) {
		this.server = server;
	}
	
	public String getServer() {
		return server;
	}
	
	public void setServerPort(String port) {
		this.port  = port;
	}
	
	public String getServerPort() {
		return this.port;
	}
	
	public void setUsername(String user) {
		this.user = user;
	}
	
	public String getUsername() {
		return user;
	}
	
	public void setPassword(String pwd) {
		this.password = pwd;
	}
	
	public String getPassword() {
		return this.password;
	}
	
	
	
	public void initDbConnection() throws Exception {
		if(provider.equals("MySQL")) {
			/* Initialize MySQL importer */
			exporter = new XMLMySQLImporter();
			exporter.initConnection(server,port,"",user,password);
		} else if(provider.equals("PostgreSQL")) {
			/* Initialize PostgreSQL importer */
			exporter = new XMLPostgreSQLImport();
			exporter.initConnection(server,port,"template1",user,password);
		}
	}
	

	public void setDatabase(String database) {
		this.db = database;
	}
	
	
	public void setLogTextbox(Text log) {
		exporter.setLogText(log);
	}
	
	public void exportData() throws Exception {
		if(tryContinueOnErrorGeneral)
			exporter.setContinueOnErrorGeneral();
		exporter.selectDatabase(db);
		exporter.setSource(source);
		exporter.exportData();
	}
	
	/**
	 * @return
	 */
	public String getContextLocation() {
		return this.ui.getContext().getContextPath();
	}
	
	public Context getContext() {
		return this.ui.getContext();
	}

	/**
	 * @param text
	 */
	public void setSource(String text) {
		this.source = text;
	}
	
	public String getSource() {
		return this.source;
	}
	
	public void setTryOnErrorGeneral(boolean selection) {
		this.tryContinueOnErrorGeneral = selection;
		System.out.println("Valore selezione: "+selection);
	}

	public void forceClose() {
		exporter.forceCloseConnection();		
	}
	
	
	
	
	

}
