/**
Master Project WS-2004 ~ SS 2005, Computer Science

University of Fribourg, Information Systems Research Group (http://diuf.unifr.ch/is)

Student :    Amos Brocco <amos.brocco@unifr.ch>
Supervisors: Prof. Dr. Andreas Meier <andreas.meier@unifr.ch>
             Nicolas Werro <nicolas.werro@unifr.ch>
        __  __
 _ _ ___\ \/ /__ _ _ _  _ _  ___
| '_/ _ \>  </ _` | ' \| ' \/ -_)
|_| \___/_/\_\__,_|_||_|_||_\___|

roXanne, Secure XML Data Storage Framework
x.core & x.click Copyright (C) 2004-2005 Amos Brocco <amos.brocco@unifr.ch>
x.mill Copyright (C) 2004-2005 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

This product includes software developed by the JDOM Project (http://www.jdom.org/).
The Jaxup library is Copyright (c) 2001 - 2003 Erwin Bolwidt, used and modified under the BSD License.
Encryption modules used are Copyright (c) 2000 - 2004 The Legion Of The Bouncy Castle (http://www.bouncycastle.org).
JAXEN  is Copyright 2003 (C) The Werken Company. All Rights Reserved.
Base64 was released as Public Domain by its author Robert Harder (rob@iharder.net)
MySQL JDBC Connector is (c) 1995-2005 MySQL AB. All rights reserved. Released under the GNU/GPL License.
PostgreSQL JDBC Driver is Copyright (c) 2004-2005 The PostgreSQL Global Development Group, distributed under the BSD license
JArgs was created Steve Purcell, now mantained by Ewan Mellorby and released under the BSD licence.
**/

/*
 * Wizard to generate a new key
 */
package wizards.genkey;

import org.eclipse.jface.wizard.Wizard;

import application.Context;

/**
 * XUpdate wizard
 * 
 * @author mriya3
 *  
 */
public class GenKeyWizard extends Wizard {

	public String algorithm;

	private Context ct;

	public ExecuteGenKeyPage dogenkey_page;

	private boolean finished = false;

	public GenKeyParamPage genkeyparam_page;

	private String keydata;

	public String password;

	private String enckeydata;

	private String deckeydata;

	/**
	 * Constructs the wizard
	 */
	public GenKeyWizard(Context ct) {
		super();
		this.ct = ct;
		setWindowTitle("Generate a new key");
		setNeedsProgressMonitor(true);
	}

	/**
	 * Add wizard pages
	 */
	public void addPages() {
		genkeyparam_page = new GenKeyParamPage(ct);
		dogenkey_page = new ExecuteGenKeyPage(ct);
		addPage(genkeyparam_page);
		addPage(dogenkey_page);
	}

	/**
	 * True if we can finish
	 */
	public boolean canFinish() {
		return finished;
	}

	/**
	 * Returns the context location value
	 * 
	 * @return algorithm name
	 */
	public String getAlgorithmName() {
		return algorithm;
	}

	/**
	 * @return
	 */
	public String getKeyData() {
		return this.keydata;
	}

	/**
	 * Returns the modification type value
	 * 
	 * @return
	 */
	public String getPassword() {
		return password;
	}

	public void isFinished() {
		this.finished = true;
	}

	/**
	 * Finishes up wizard
	 */
	public boolean performFinish() {
		return true;
	}

	/**
	 * Sets the context location value
	 * 
	 * @param location
	 */
	public void setAlgorithmName(String name) {
		this.algorithm = name;
	}

	/**
	 * @param keydata
	 */
	public void setKeyData(String keydata) {
		this.keydata = keydata;
	}

	/**
	 * Sets the modification type value
	 * 
	 * @param modification
	 */
	public void setPassword(String pwd) {
		this.password = pwd;
	}

	/**
	 * Sets the encryption key data
	 * @param enckeydata
	 */
	public void setEncKeyData(String enckeydata) {
		this.enckeydata = enckeydata;
	}
	
	/**
	 * Returns the encryption key
	 * @return
	 */
	public String getEncKeyData() {
		return this.enckeydata;
	}
	
	/**
	 * Sets the decryption key data
	 * @param deckeydata
	 */
	public void setDecKeyData(String deckeydata) {
		this.deckeydata = deckeydata;
	}
	
	/**
	 * Returns the decryption key
	 * @return
	 */
	public String getDecKeyData() {
		return this.deckeydata;
	}
	

}
