/**
Master Project WS-2004 ~ SS-2005, Computer Science

University of Fribourg, Information Systems Research Group (http://diuf.unifr.ch/is)

Students :   Amos Brocco <amos.brocco@unifr.ch>
			 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>
Supervisors: Prof. Dr. Andreas Meier <andreas.meier@unifr.ch>
             Nicolas Werro <nicolas.werro@unifr.ch>
        __  __
 _ _ ___\ \/ /__ _ _ _  _ _  ___
| '_/ _ \>  </ _` | ' \| ' \/ -_)
|_| \___/_/\_\__,_|_||_|_||_\___|

roXanne, Secure XML Data Storage Framework
x.core & x.click Copyright (C) 2004-2005 Amos Brocco <amos.brocco@unifr.ch>
x.mill Copyright (C) 2004-2005 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

This product includes software developed by the JDOM Project (http://www.jdom.org/).
The Jaxup library is Copyright (c) 2001 - 2003 Erwin Bolwidt, used and modified under the BSD License.
Encryption modules used are Copyright (c) 2000 - 2004 The Legion Of The Bouncy Castle (http://www.bouncycastle.org).
JAXEN  is Copyright 2003 (C) The Werken Company. All Rights Reserved.
Base64 was released as Public Domain by its author Robert Harder (rob@iharder.net)
MySQL JDBC Connector is (c) 1995-2005 MySQL AB. All rights reserved. Released under the GNU/GPL License.
PostgreSQL JDBC Driver is Copyright (c) 2004-2005 The PostgreSQL Global Development Group, distributed under the BSD license
JArgs was created Steve Purcell, now mantained by Ewan Mellorby and released under the BSD licence.
**/

/*
 * Executes an XUpdate query
 */
package wizards.importfromdb;

import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import application.Context;

/**
 * @author mriya3
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class XmillPage4 extends WizardPage {

	private Context context;

	private Text logText;

	private Button saveLogButton;
	
	private Button saveDataButton;

	private String location;

	private String modification;

	private String command;
	
	private Text locText;
	
	private boolean canContinue = false;

	private boolean finished = false;
	
	boolean canImport = false;

	protected XmillPage4() {
		super("ExecuteXmillPage");
		setTitle("Extracting data");
		setDescription("Extracting data from database. See log for information");
	}

	/**
	 * Creates this page
	 */
	public void createControl(Composite composite) {
		Composite container = new Composite(composite, SWT.NULL);
		GridLayout layout = new GridLayout();
		container.setLayout(layout);
		layout.numColumns = 1;
		layout.verticalSpacing = 5;

		GridData gd = new GridData(GridData.FILL_HORIZONTAL);

		Label logLabel = new Label(container, SWT.NULL);
		logLabel.setText("Operation log: ");

		logText = new Text(container, SWT.BORDER | SWT.MULTI);
		GridData gd2 = new GridData(GridData.FILL_BOTH);
		logText.setLayoutData(gd2);
		
		Composite bar = new Composite(container, SWT.NULL);
		GridLayout barlayout = new GridLayout();
		bar.setLayout(barlayout);
		barlayout.numColumns = 2;
		barlayout.verticalSpacing = 5;

		saveLogButton = new Button(bar, SWT.NULL | SWT.RIGHT);
		saveLogButton.setText("Save log...");
		saveLogButton.setEnabled(true);
		saveLogButton.addSelectionListener(new SelectionListener() {
			public void widgetSelected(SelectionEvent e) {
				DataOutputStream out = null;
				try {
					FileDialog fd = new FileDialog(getShell(), SWT.SAVE);
					fd.setText("Save log to file");
					fd.setFilterPath(System.getProperty("os.path"));
					String[] filterExt = { "*.rsk", "*.*" };
					fd.setFilterExtensions(filterExt);
					String selected = fd.open();
					File file = new File(selected);
					out = new DataOutputStream(new FileOutputStream(file));
					out.writeUTF(logText.getText());
					out.close();
					logText.append("\nLog saved to file: " + selected);
				} catch (Exception e1) {
					logText.append("\nCannot save log to file!");
					try {
						if (out != null)
							out.close();
					} catch (IOException e2) {
						e2.printStackTrace();
					}
				}
			}

			public void widgetDefaultSelected(SelectionEvent e) {
			}
		});
		
		saveDataButton = new Button(bar, SWT.NULL | SWT.RIGHT);
		saveDataButton.setText("Save data...");
		saveDataButton.setEnabled(false);
		saveDataButton.addSelectionListener(new SelectionListener() {
			public void widgetSelected(SelectionEvent e) {
				DataOutputStream out = null;
				try {
					FileDialog fd = new FileDialog(getShell(), SWT.SAVE);
					fd.setText("Save data to file");
					fd.setFilterPath(System.getProperty("os.path"));
					String[] filterExt = { "*.xml", "*.*" };
					fd.setFilterExtensions(filterExt);
					String selected = fd.open();
					File file = new File(selected);
					out = new DataOutputStream(new FileOutputStream(file));
					XmillWizard wizard = (XmillWizard) getWizard();
					out.writeBytes(wizard.getXMLData());
					out.close();
					logText.append("\nData saved to file: " + selected);
				} catch (Exception e1) {
					logText.append("\nCannot save data to file!");
					try {
						if (out != null)
							out.close();
					} catch (IOException e2) {
						e2.printStackTrace();
					}
				}
			}

			public void widgetDefaultSelected(SelectionEvent e) {
			}
		});



		
		Label locLabel = new Label(container, SWT.NULL);
		locLabel.setText("Destination: ");

		locText = new Text(container, SWT.BORDER | SWT.SINGLE);
		locText.setLayoutData(gd);
		XmillWizard wizard = (XmillWizard) getWizard();
		locText.setText(wizard.getContextLocation());	
		
		locText.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				validate();
			}
		});
		
		setPageComplete(false);
		setControl(container);
	}

	void onEnterPage() {
		canContinue = false;
		XmillWizard wizard = (XmillWizard) getWizard();
		wizard.setLogTextbox(logText);
		canImport = true;
		try {
			wizard.exportData();
		} catch (Exception e) {
			logText.append("An error has occurred while extracting data");
			
			canImport = false;
			canContinue = false;
			getWizard().getContainer().updateButtons();
		} finally {
			wizard.forceClose();
		}
		if(canImport) {
			logText.append("Done.");
			saveDataButton.setEnabled(true);
			canContinue = true;
			validate();
		}			
	}

	public boolean canFlipToNextPage() {
		return canContinue;
	}
	

	private void validate() {
		if (locText.getText().trim().length() == 0) {
			updateStatus("Import location must be specified.");
			return;
		}
		
		if(!(canImport)) {
			updateStatus("Error on data extraction.");
			return;
		}
			
		saveData();
		canContinue = true;
		getWizard().getContainer().updateButtons();
		updateStatus(null);
	}

	private void updateStatus(String message) {
		setErrorMessage(message);
	}
	
	public void saveData() {
		XmillWizard wizard = (XmillWizard) getWizard();
		wizard.setImportLocation(locText.getText());
	}

	public IWizardPage getNextPage() {
		saveData();
		XmillPage5 page = (XmillPage5) ((XmillWizard) getWizard()).page5;
		page.onEnterPage();
		return page;
	}

}
