/**
Master Project WS-2004 ~ SS-2005, Computer Science

University of Fribourg, Information Systems Research Group (http://diuf.unifr.ch/is)

Students :   Amos Brocco <amos.brocco@unifr.ch>
			 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>
Supervisors: Prof. Dr. Andreas Meier <andreas.meier@unifr.ch>
             Nicolas Werro <nicolas.werro@unifr.ch>
        __  __
 _ _ ___\ \/ /__ _ _ _  _ _  ___
| '_/ _ \>  </ _` | ' \| ' \/ -_)
|_| \___/_/\_\__,_|_||_|_||_\___|

roXanne, Secure XML Data Storage Framework
x.core & x.click Copyright (C) 2004-2005 Amos Brocco <amos.brocco@unifr.ch>
x.mill Copyright (C) 2004-2005 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

This product includes software developed by the JDOM Project (http://www.jdom.org/).
The Jaxup library is Copyright (c) 2001 - 2003 Erwin Bolwidt, used and modified under the BSD License.
Encryption modules used are Copyright (c) 2000 - 2004 The Legion Of The Bouncy Castle (http://www.bouncycastle.org).
JAXEN  is Copyright 2003 (C) The Werken Company. All Rights Reserved.
Base64 was released as Public Domain by its author Robert Harder (rob@iharder.net)
MySQL JDBC Connector is (c) 1995-2005 MySQL AB. All rights reserved. Released under the GNU/GPL License.
PostgreSQL JDBC Driver is Copyright (c) 2004-2005 The PostgreSQL Global Development Group, distributed under the BSD license
JArgs was created Steve Purcell, now mantained by Ewan Mellorby and released under the BSD licence.
**/

/*
 * Executes an XUpdate query
 */
package wizards.importfromdb;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;

import application.Context;
import application.Executor;
import application.ExecutorCallbacksListener;

/**
 * @author mriya3
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class XmillPage5 extends WizardPage {

	private Context context;

	private Text logText;

	private Button saveLogButton;

	private String location;

	private boolean canContinue;

	private boolean finished = false;

	private String data;

	class XUpdateResultListener implements ExecutorCallbacksListener {

		public void dataAvailable(Executor ex, final String request,
				BufferedReader response) {

			Document doc = null;
			try {
				/* Parse result */
				doc = (new SAXBuilder()).build(response);
			} catch (final JDOMException e) {
				/* Sync start */context.getDisplay().syncExec(new Runnable() {
					public void run() {
						logText.append("Cannot execute xupdate " + request);
						e.printStackTrace();
						/* Sync end */}
				});
				return;
			} catch (final IOException e) {
				/* Sync start */context.getDisplay().syncExec(new Runnable() {
					public void run() {
						logText.append("Cannot connect to server");
						e.printStackTrace();
						/* Sync end */}
				});
				return;
			}

			/* Parse tree */
			Element rootNode = doc.getRootElement();
			Element requests = rootNode.getChild("requests");
			Element action = requests.getChild("action");
			Element result = action.getChild("result");
			String exitCode = result.getAttributeValue("exitCode");
			final Element description = result.getChild("description");
			final Element detail = result.getChild("detail");

			if (exitCode.equals("200"))
				/* Sync start */context.getDisplay().syncExec(new Runnable() {
					public void run() {
						logText.append("Done!");
						setPageComplete(true);
						canContinue = true;
						((XmillWizard) (getWizard())).isFinished();
						getWizard().getContainer().updateButtons();
						/* Sync end */}
				});
			else
				/* Sync start */context.getDisplay().syncExec(new Runnable() {
					public void run() {
						logText
								.append("Error! " + description.getText()
										+ "\n");
						logText.append("Reason: " + detail.getText() + "\n");
						setPageComplete(false);
						/* Sync end */}
				});

		}
	}

	protected XmillPage5(Context context) {
		super("ExecuteXUpdatePage");
		setTitle("Execute importation query");
		setDescription("Importing data. See log for information");
		this.context = context;
	}

	/**
	 * Creates this page
	 */
	public void createControl(Composite composite) {
		Composite container = new Composite(composite, SWT.NULL);
		GridLayout layout = new GridLayout();
		container.setLayout(layout);
		layout.numColumns = 1;
		layout.verticalSpacing = 5;

		GridData gd = new GridData(GridData.FILL_HORIZONTAL);

		Label logLabel = new Label(container, SWT.NULL);
		logLabel.setText("Operation log: ");

		logText = new Text(container, SWT.BORDER | SWT.MULTI | SWT.V_SCROLL);
		GridData gd2 = new GridData(GridData.FILL_BOTH);
		logText.setLayoutData(gd2);

		saveLogButton = new Button(container, SWT.NULL | SWT.RIGHT);
		saveLogButton.setText("Save log...");
		saveLogButton.setEnabled(true);
		saveLogButton.addSelectionListener(new SelectionListener() {
			public void widgetSelected(SelectionEvent e) {
				DataOutputStream out = null;
				try {
					FileDialog fd = new FileDialog(getShell(), SWT.SAVE);
					fd.setText("Save log to file");
					fd.setFilterPath(System.getProperty("os.path"));
					String[] filterExt = { "*.txt", "*.*" };
					fd.setFilterExtensions(filterExt);
					String selected = fd.open();
					File file = new File(selected);
					out = new DataOutputStream(new FileOutputStream(file));
					out.writeUTF(logText.getText());
					out.close();
					logText.append("\nLog saved to file: " + selected);
				} catch (Exception e1) {
					logText.append("\nCannot save log to file!");
					try {
						if (out != null)
							out.close();
					} catch (IOException e2) {
						e2.printStackTrace();
					}
				}
			}

			public void widgetDefaultSelected(SelectionEvent e) {
			}
		});


		setPageComplete(false);
		setControl(container);
	}

	/**
	 * Performs some actions when accessing this page
	 *  
	 */
	void onEnterPage() {
		XmillWizard wizard = (XmillWizard) getWizard();
		data = wizard.getXMLData();
		location = wizard.getImportLocation();
		logText.append("Importing data to <"+location+">...\n");
		executeXUpdate();
	}

	/**
	 * Launch XUpdate execution
	 */
	private void executeXUpdate() {
		int crpos = data.indexOf('\n');
		data = data.substring(crpos);
		System.out.println(data);
		Document modCmd = null;
		String query = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><roxannequery login=\""
				+ context.getSession().getLogin()
				+ "\" password=\""
				+ context.getSession().getPassword()
				+ "\" sessionId=\""
				+ context.getSession().getSessionId()
				+ "\" persistent=\"true\"><requests><action type=\"xupdate\" version=\"1.0\" xmlns:xupdate=\"http://www.xmldb.org/xupdate\"><xupdate:append select=\""
				+ location
				+ "\">"
				+ data
				+ "</xupdate:append></action></requests></roxannequery>";
		System.out.println(query);
		Executor ex = new Executor(new XUpdateResultListener(), context
				.getSession());
		ex.setQuery(query);
		ex.start();
	}

	/**
	 * Returns if we can go to next page (finish)
	 */
	public boolean canFlipToNextPage() {
		return false;
	}

}
